// ;-*-C-*- *  Time-stamp: "2008-07-01 00:46:46 hmmr"

/***************************************************************************
 *            agh_enums.h
 *
 *  Copyright  2008  Andrei Zavada
 *  Email johnhommer@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef AGH_ENUMS_H
#define AGH_ENUMS_H


typedef enum {
	AGH_SUBJECT_GENDER_NEUTER = 'o',
	AGH_SUBJECT_GENDER_MALE   = 'M',
	AGH_SUBJECT_GENDER_FEMALE = 'F'
} TGender;


typedef enum {
	AGH_SRCATTACH_COPY,
	AGH_SRCATTACH_MOVE,
	AGH_SRCATTACH_LINK,
	AGH_SRCATTACH_LEAVE
} TSourceAttachMode;



typedef enum {
	AGH_SCORE_NONE,
	AGH_SCORE_NREM1,
	AGH_SCORE_NREM2,
	AGH_SCORE_NREM3,
	AGH_SCORE_NREM4,
	AGH_SCORE_WAKE,
	AGH_SCORE_REM,
	AGH_SCORE_MVT
} TScores;



typedef enum {
	AGH_WT_BARTLETT,
	AGH_WT_BLACKMAN,
	AGH_WT_BLACKMAN_HARRIS,
	AGH_WT_HAMMING,
	AGH_WT_HANNING,
	AGH_WT_PARZEN,
	AGH_WT_SQUARE,
	AGH_WT_WELCH,
	AGH_WT_N_TYPES
} TFFTWinType;



enum {
	AGH_Vrs,	AGH_Vrc,
	AGH_Vfc_R,	AGH_Vfc_W,
	AGH_VS_0,	AGH_VS_U,
	AGH_Vt_a,	AGH_Vt_p,
	AGH_Vgc,
	AGH_VNUM
};

#define AGH_EGC_MAX 6




enum {
	AGH_SIMPREP_ENOSCORE		= -5,
	AGH_SIMPREP_EFARAPART		= -6,
	AGH_SIMPREP_ESIGTYPE		= -7,
	AGH_SIMPREP_ETOOMANYMSMT	= -8,
	AGH_SIMPREP_ENOMSMT		= -9,
	AGH_SIMPREP_EAMENDMENTS_INEFFECTIVE	= -10,
	AGH_SIMPREP_ERS_NONSENSICAL		= -11
};



enum {
	AGH_SIMCYCLE_ENAN	= -1,
	AGH_SIMCYCLE_EHITMAX	= -2,
	AGH_SIMCYCLE_EHITMIN	= -3,
	AGH_SIMCYCLE_ESUS0CRASH	= -4
};


#define AGH_MODRUN_INMEM		 1
#define AGH_MODRUN_PREPARED		(1 << 1)
#define AGH_MODRUN_FITSUFFICIENT	(1 << 2)
#define AGH_MODRUN_ALLSTABLE		(1 << 3)
#define AGH_MODRUN_ALLREQSTABLE		(1 << 4)
#define AGH_MODRUN_FAILED		(1 << 5)


#define AGH_MVT_WAKE_VALUE	.001

enum {
	AGH_BATCHRUN_REDOSKIP,
	AGH_BATCHRUN_REDOFAILED,
	AGH_BATCHRUN_REDOSUCCEEDED,
	AGH_BATCHRUN_REDOALWAYS,
	AGH_BATCHRUN_N_REDO_OPTIONS
};


#endif

// EOF
