// ;-*-C++-*- *  Time-stamp: "2008-06-22 18:59:52 hmmr"

/***************************************************************************
 *            agh_iface.cc
 *
 *  Copyright  2008  Andrei Zavada
 *  Email johnhommer@gmail.com

 *  Parts of expdesign/data having ui controls.  We populate the
 *  GtkTreeStore objects, both those populated once at startup and
 *  other ones that change on every redisplay.
 *
 *  Subsequently, other functions defined here manage synchronisation of treemodels
 *  with the core structures.  Callbacks in agh-ui are simply wrappers for these.
 *
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gtk/gtk.h>

#include "agh_iface.hh"
#include "agh_io.hh"
#include "agh_expdesign.hh"



CExpDesign *AghCC;


//gint agh_n_current_episodes = -1; // delete me
gint agh_current_session;

// this one is properly a seq_no, but due to its being accurately
// handled by agh_*_channel functions, it's safe to assume it
// indicates a valid position of a channel in agh_mDesignSetupChannels
// and its seq_no
gint agh_current_channel;


GString *agh_j_name;
GString *agh_e_name;



gint
agh_expdesign_init()
{
	AghCC = new CExpDesign( agh_last_expdesign_dir);
	AghCC->load();
	AghCC->collect_msmts_from_tree();
	AghCC->collect_simulations_from_tree();

	if ( agh_current_channel < 0 || agh_current_channel >= AghCC->channel_names->n() )
		agh_current_channel = 0;
	if ( agh_current_session < 0 || agh_current_session >= AghCC->sessions->n() )
		agh_current_session = 0;

	agh_j_name = g_string_sized_new( 50);
	agh_e_name = g_string_sized_new( 50);

	agh_populate_models();

	return !(AghCC && AghCC->is_ok());
}


gint
agh_expdesign_shutdown()
{
	AghCC->save();

	g_string_free( agh_j_name, TRUE);
	g_string_free( agh_e_name, TRUE);

	agh_current_channel = agh_current_session = -1;

	delete AghCC;
	return 0;
}






void
agh_dump_all()
{
	printf( "\n"
		"==================================\n"
		"======== DUMP ======\n");
	printf( "\n---- Subjects ----\n");
	AghCC->subjects->dump();
	printf( "\n---- Sources -----\n");
	AghCC->sources->dump();
	printf( "\n-- Measurements --\n");
	AghCC->measurements->dump();
	printf( "\n----- Groups -----\n");
	AghCC->groups->dump();
	printf( "\n---- Sessions ----\n");
	AghCC->sessions->dump();
	printf( "\n-- Episode names -\n");
	AghCC->episode_names->dump();
	printf( "\n-- Channel names -\n");
	AghCC->channel_names->dump();
	printf( "\n-- Simulations ---\n");
	AghCC->simulations->dump();
}


// EOF
