// ;-*-C-*- *  Time-stamp: "2008-06-26 16:43:42 hmmr"

/***************************************************************************
 *            agh_ui-design-measurements.c
 *
 *  Copyright  2008  Andrei Zavada
 *  Email johnhommer@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <glade/glade.h>
#include "agh_iface.hh"
#include "agh_ui.h"



GtkTreeStore	*agh_mDesignMeasurements;

GtkWidget
	*tvDesignMeasurements,
	*eDesignMsmtChannel,
	*eDesignMsmtSession;


void eDesignMsmtSession_changed_cb();
void eDesignMsmtChannel_changed_cb();





gint
agh_construct_DesignMeasurements( GladeXML *xml)
{
	GtkCellRenderer *renderer;

     // ------------- tvDesignMeasurements
	if ( !(tvDesignMeasurements = glade_xml_get_widget( xml, "tvDesignMeasurements")) )
		return -1;

	gtk_tree_view_set_model( GTK_TREE_VIEW (tvDesignMeasurements),
				 GTK_TREE_MODEL (agh_mDesignMeasurements));

	g_object_set( G_OBJECT (tvDesignMeasurements),
		      "expander-column", 0,
		      "enable-tree-lines", FALSE,
		      "headers-clickable", FALSE,
		      NULL);
	g_signal_connect( tvDesignMeasurements, "map", G_CALLBACK (gtk_tree_view_expand_all), NULL);

	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer),
		      "editable", FALSE,
		      NULL);
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignMeasurements),
						     -1, "Subject", renderer,
						     "text", 0,
						     NULL);
	// give 'em enough sleep episodes!
	guint m;
	for ( m = 0; m < 16; m++ ) {
		renderer = gtk_cell_renderer_text_new();
		g_object_set( G_OBJECT (renderer),
			      "editable", FALSE,
			      NULL);
		g_object_set_data( G_OBJECT (renderer), "column", GINT_TO_POINTER (m+1));
		gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignMeasurements),
							     -1, "sleep-episode", renderer,
							     "text", m+1,
							     "visible", 17,
							     NULL);
	}


     // ------------- eDesignMsmtSession
	if ( !(eDesignMsmtSession = glade_xml_get_widget( xml, "eDesignMsmtSession")) )
		return -1;

	gtk_combo_box_set_model( GTK_COMBO_BOX (eDesignMsmtSession),
				 GTK_TREE_MODEL (agh_mDesignSetupSessions));
	g_signal_connect( eDesignMsmtSession, "changed", eDesignMsmtSession_changed_cb, NULL);
	renderer = gtk_cell_renderer_text_new();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (eDesignMsmtSession), renderer, FALSE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (eDesignMsmtSession), renderer,
					"text", 0,
					NULL);

     // ------------- eDesignMsmtChannel
	if ( !(eDesignMsmtChannel = glade_xml_get_widget( xml, "eDesignMsmtChannel")) )
		return -1;

	gtk_combo_box_set_model( GTK_COMBO_BOX (eDesignMsmtChannel),
				 GTK_TREE_MODEL (agh_mDesignSetupChannels));
	g_signal_connect( eDesignMsmtChannel, "changed", eDesignMsmtChannel_changed_cb, NULL);

	renderer = gtk_cell_renderer_text_new();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (eDesignMsmtChannel), renderer, FALSE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (eDesignMsmtChannel), renderer,
					"text", 0,
					NULL);

	return 0;
}






void
tvDesignMeasurements_expose_event_cb()
{
	agh_collect_msmts_from_tree();
	agh_populate_mDesignMeasurements();
}





void
eDesignMsmtSession_changed_cb()
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignMeasurements);

	agh_current_session = gtk_combo_box_get_active( GTK_COMBO_BOX (eDesignMsmtSession));
	__agh_propagate_current_session_change();

	agh_populate_mDesignMeasurements();
}




void
eDesignMsmtChannel_changed_cb()
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignMeasurements);

	agh_current_channel = gtk_combo_box_get_active( GTK_COMBO_BOX (eDesignMsmtChannel));
	__agh_propagate_current_channel_change();

	agh_populate_mDesignMeasurements();
}

















void
eOddSubjectGroups_changed_cb()
{
	gtk_widget_set_sensitive( bOddSubjectGroupSelect, TRUE);
}







static __single_channel_wScoringFacility_height = 0;


void
tvDesignMeasurements_row_activated_cb( GtkTreeView *tree_view,
				       GtkTreePath *path,
				       GtkTreeViewColumn *column,
				       gpointer     userdata)
{
	static GString *title = NULL;
	if ( !title )
		title = g_string_sized_new( 120);

	const gchar *e_name = gtk_tree_view_column_get_title( column);

	if ( strcmp( e_name, "Subject") && gtk_tree_path_get_depth( path) > 1 ) {
		gchar *j_name;
		GtkTreeIter iter;
		gtk_tree_model_get_iter( GTK_TREE_MODEL (agh_mDesignMeasurements), &iter, path);
		gtk_tree_model_get( GTK_TREE_MODEL (agh_mDesignMeasurements), &iter,
				    0, &j_name,
				    -1);

		g_string_assign( agh_j_name, j_name);
		g_string_assign( agh_e_name, e_name);

		if ( (agh_msmt_has_edf(         agh_j_name->str, agh_e_name->str, agh_get_current_channel_name()) ||
		      agh_msmt_has_powercourse( agh_j_name->str, agh_e_name->str, agh_get_current_channel_name())) &&
		     __agh_prepare_score_facility() ) {
			if ( __single_channel_wScoringFacility_height )
				gtk_window_resize( GTK_WINDOW (wScoringFacility), 1200,
						   __single_channel_wScoringFacility_height);
			gtk_widget_show_all( wScoringFacility);
			g_string_printf( title, "Scoring facility: %s %s", agh_j_name->str, agh_e_name->str);
			gtk_window_set_title( GTK_WINDOW (wScoringFacility),
					      title->str);
		}
		g_free( j_name);
	}
}


gboolean
wScoringFacility_configure_event_cb( GtkWidget *widget,
				     GdkEventConfigure *event,
				     gpointer unused)
{
	if ( __single_channel_wScoringFacility_height == 0 )
		__single_channel_wScoringFacility_height = event->height;
	return FALSE;
}


// EOF
