// ;-*-C-*- *  Time-stamp: "2008-06-05 22:08:26 hmmr"

/***************************************************************************
 *            agh_ui-design.c
 *
 *  Copyright  2008  Andrei Zavada
 *  Email johnhommer@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <glade/glade.h>
#include "agh_iface.hh"
#include "agh_ui.h"




GtkTreeStore *agh_mDesignSetupGroupsSubjects;
GtkListStore *agh_mDesignSetupGroups;
GtkListStore *agh_mDesignSetupEpisodes;
GtkListStore *agh_mDesignSetupSessions;
GtkListStore *agh_mDesignSetupChannels;
GtkListStore *agh_mDesignSetupSources;



GtkWidget
	*tvDesignSetupGroupsSubjects,
	*tvDesignSetupEpisodes,
	*tvDesignSetupSessions,
	*tvDesignSetupChannels,

	*wEDFChooser,
	*bEDFChooserOptionMove,
	*bEDFChooserOptionCopy,
	*bEDFChooserOptionLink,
	*bEDFChooserOptionLeave,

	*bOddSubjectGroupSelect,

	*tvDesignSetupSources;

static GtkWidget
	*wOddSubjectGroupChooser,
	*eOddSubjectGroups,
	*lOddSubjectGroupSubject,

	*wEDFFileDetails,
	*lEDFFileDetailsReport,
	*cEDFFileDetailsParseProblemsShow,
	*lEDFFileDetailsParseProblems;



// callbacks autoconnected by libglade need not be declared;
// other callbacks (those manually connected) follow
void eDesignSetupSubjectCell_edited( GtkCellRendererText*, const gchar*, const gchar*, gpointer);
void eDesignSetupEpisodeCell_edited( GtkCellRendererText*, const gchar*, const gchar*, gpointer);
void eDesignSetupSessionCell_edited( GtkCellRendererText*, const gchar*, const gchar*, gpointer);
void eDesignSetupChannelCell_edited( GtkCellRendererText*, const gchar*, const gchar*, gpointer);



void
__agh_propagate_current_session_change()
{
	if ( agh_current_session != gtk_combo_box_get_active( GTK_COMBO_BOX (eDesignMsmtSession)) )
		gtk_combo_box_set_active( GTK_COMBO_BOX (eDesignMsmtSession), agh_current_session);
	if ( agh_current_session != gtk_combo_box_get_active( GTK_COMBO_BOX (eSimulationsSession)) )
		gtk_combo_box_set_active( GTK_COMBO_BOX (eSimulationsSession), agh_current_session);
}
void
__agh_propagate_current_channel_change()
{
	if ( agh_current_channel != gtk_combo_box_get_active( GTK_COMBO_BOX (eDesignMsmtChannel)) )
		gtk_combo_box_set_active( GTK_COMBO_BOX (eDesignMsmtChannel), agh_current_channel);
	if ( agh_current_channel != gtk_combo_box_get_active( GTK_COMBO_BOX (eSimulationsChannel)) )
		gtk_combo_box_set_active( GTK_COMBO_BOX (eSimulationsChannel), agh_current_channel);
}



void
__agh__disconnect_channels_combo()
{
	gtk_combo_box_set_model( GTK_COMBO_BOX (eDesignMsmtChannel), NULL);
	gtk_combo_box_set_model( GTK_COMBO_BOX (eSimulationsChannel), NULL);
}

void
__agh__reconnect_channels_combo()
{
	gtk_combo_box_set_model( GTK_COMBO_BOX (eDesignMsmtChannel),   GTK_TREE_MODEL (agh_mDesignSetupChannels));
	gtk_combo_box_set_model( GTK_COMBO_BOX (eSimulationsChannel),  GTK_TREE_MODEL (agh_mDesignSetupChannels));

	if ( agh_current_channel < 0 || agh_current_channel >= agh_get_n_channels() )
		agh_current_channel = 0;

	gtk_combo_box_set_active( GTK_COMBO_BOX (eDesignMsmtChannel),   agh_current_channel);
	gtk_combo_box_set_active( GTK_COMBO_BOX (eSimulationsChannel),  agh_current_channel);
}

void
__agh__disconnect_sessions_combo()
{
	gtk_combo_box_set_model( GTK_COMBO_BOX (eDesignMsmtSession),   NULL);
	gtk_combo_box_set_model( GTK_COMBO_BOX (eSimulationsSession),  NULL);
}

void
__agh__reconnect_sessions_combo()
{
	gtk_combo_box_set_model( GTK_COMBO_BOX (eDesignMsmtSession),   GTK_TREE_MODEL (agh_mDesignSetupSessions));
	gtk_combo_box_set_model( GTK_COMBO_BOX (eSimulationsSession),  GTK_TREE_MODEL (agh_mDesignSetupSessions));

	if ( agh_current_session < 0 || agh_current_session >= agh_get_n_sessions() )
		agh_current_session = 0;

	gtk_combo_box_set_active( GTK_COMBO_BOX (eDesignMsmtSession),   agh_current_session);
	gtk_combo_box_set_active( GTK_COMBO_BOX (eSimulationsSession),  agh_current_session);
}



void
__agh__disconnect_pagesize_combo()
{
	gtk_combo_box_set_model( GTK_COMBO_BOX (ePageSize), NULL);
	gtk_combo_box_set_model( GTK_COMBO_BOX (eScoringFacPageSize), NULL);
}
void
__agh__reconnect_pagesize_combo()
{
	gtk_combo_box_set_model( GTK_COMBO_BOX (ePageSize), GTK_TREE_MODEL (agh_mPageSize));
	gtk_combo_box_set_model( GTK_COMBO_BOX (eScoringFacPageSize), GTK_TREE_MODEL (agh_mPageSize));
}







// ------------------ construct

gint
agh_construct_DesignSetup( GladeXML *xml)
{
//	printf( "Construct DesignSetup...");
	GtkCellRenderer *renderer;

     // ---------------- tvDesignSetupGroupsSubjects

	if ( !(tvDesignSetupGroupsSubjects = glade_xml_get_widget( xml, "tvDesignSetupGroupsSubjects")) )
		return -1;
	gtk_tree_view_set_model( GTK_TREE_VIEW  (tvDesignSetupGroupsSubjects),
				 GTK_TREE_MODEL (agh_mDesignSetupGroupsSubjects));

	g_object_set( G_OBJECT (tvDesignSetupGroupsSubjects),
		      "expander-column", 0,
		      "enable-tree-lines", FALSE,
		      "headers-clickable", FALSE,
		      NULL);
	gtk_tree_view_set_reorderable( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects), FALSE);
	g_signal_connect( tvDesignSetupGroupsSubjects, "map",
			  G_CALLBACK (gtk_tree_view_expand_all), NULL);

	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer),
		      "editable", TRUE,
		      NULL);
	g_signal_connect( renderer, "edited",
			  G_CALLBACK (eDesignSetupSubjectCell_edited), agh_mDesignSetupGroupsSubjects);
	g_object_set_data( G_OBJECT (renderer), "column", GINT_TO_POINTER (0));
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects),
						     -1, "Group/Subject", renderer,
						     "text", 0,
						     NULL);
	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer),
		      "editable", TRUE,
		      NULL);
	g_signal_connect( renderer, "edited",
			  G_CALLBACK (eDesignSetupSubjectCell_edited), agh_mDesignSetupGroupsSubjects);
	g_object_set_data( G_OBJECT (renderer), "column", GINT_TO_POINTER (1));
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects),
						     -1, "Gender", renderer,
						     "text", 1,
						     "visible", 4,
						     NULL);
	renderer = gtk_cell_renderer_spin_new();
	g_object_set( G_OBJECT (renderer),
		      "editable", TRUE,
		      "adjustment", gtk_adjustment_new( 31, 12, 120, 1, 5, 5),
		      "width", 35,
		      NULL);
	g_signal_connect( renderer, "edited",
			  G_CALLBACK (eDesignSetupSubjectCell_edited), agh_mDesignSetupGroupsSubjects);
	g_object_set_data( G_OBJECT (renderer), "column", GINT_TO_POINTER (2));
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects),
						     -1, "Age", renderer,
						     "text", 2,
						     "visible", 4,
						     NULL);
	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer),
		      "editable", TRUE,
		      NULL);
	g_signal_connect( renderer, "edited",
			  G_CALLBACK (eDesignSetupSubjectCell_edited), agh_mDesignSetupGroupsSubjects);
	g_object_set_data( G_OBJECT (renderer), "column", GINT_TO_POINTER (3));
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects),
						     -1, "Comment", renderer,
						     "text", 3,
						     "visible", 4,
						     NULL);


     // ----------------- tvDesignSetupEpisodes

	if ( !(tvDesignSetupEpisodes = glade_xml_get_widget( xml, "tvDesignSetupEpisodes")) )
		return -1;

	gtk_tree_view_set_model( GTK_TREE_VIEW (tvDesignSetupEpisodes),
				 GTK_TREE_MODEL (agh_mDesignSetupEpisodes));

	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer),
		      "editable", TRUE,
		      NULL);
	g_signal_connect( renderer, "edited",
			  G_CALLBACK (eDesignSetupEpisodeCell_edited), agh_mDesignSetupEpisodes);
	g_object_set_data( G_OBJECT (renderer), "column", GINT_TO_POINTER (0));
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupEpisodes),
						     -1, "Name", renderer,
						     "text", 0,
						     NULL);

     // ----------------- tvDesignSetupSessions

	if ( !(tvDesignSetupSessions = glade_xml_get_widget( xml, "tvDesignSetupSessions")) )
		return -1;

	gtk_tree_view_set_model( GTK_TREE_VIEW (tvDesignSetupSessions),
				 GTK_TREE_MODEL (agh_mDesignSetupSessions));

	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer),
		      "editable", TRUE,
		      NULL);
	g_signal_connect( renderer, "edited",
			  G_CALLBACK (eDesignSetupSessionCell_edited), agh_mDesignSetupSessions);
	g_object_set_data( G_OBJECT (renderer), "column", GINT_TO_POINTER (0));
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupSessions),
						     -1, "Name", renderer,
						     "text", 0,
						     NULL);


     // construct tvDesignSetupChannels ---------------

	if ( !(tvDesignSetupChannels = glade_xml_get_widget( xml, "tvDesignSetupChannels")) )
		return -1;

	gtk_tree_view_set_model( GTK_TREE_VIEW (tvDesignSetupChannels),
				 GTK_TREE_MODEL (agh_mDesignSetupChannels));

	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer),
		      "editable", TRUE,
		      NULL);
	g_signal_connect( renderer, "edited",
			  G_CALLBACK (eDesignSetupChannelCell_edited), agh_mDesignSetupChannels);
	g_object_set_data( G_OBJECT (renderer), "column", GINT_TO_POINTER (0));
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupChannels),
						     -1, "Name", renderer,
						     "text", 0,
						     NULL);

     // ------------- tvDesignSetupSources
	if ( !(tvDesignSetupSources = glade_xml_get_widget( xml, "tvDesignSetupSources")) )
		return -1;

	GtkTreeModel *sort_model = gtk_tree_model_sort_new_with_model( GTK_TREE_MODEL (agh_mDesignSetupSources));
	gtk_tree_view_set_model( GTK_TREE_VIEW (tvDesignSetupSources),
				 sort_model);

	g_object_set( G_OBJECT (tvDesignSetupSources),
		      "enable-tree-lines", FALSE,
		      "headers-clickable", TRUE,
		      NULL);
	gtk_tree_view_set_headers_clickable( GTK_TREE_VIEW (tvDesignSetupSources), TRUE);

	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer), "editable", FALSE, NULL);
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupSources),
						     -1, "Subject", renderer,
						     "text", 0,
						     NULL);
	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer), "editable", FALSE, NULL);
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupSources),
						     -1, "Channels", renderer,
						     "text", 1,
						     NULL);
	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer), "editable", FALSE, NULL);
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupSources),
						     -1, "Session", renderer,
						     "text", 2,
						     NULL);
	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer), "editable", FALSE, NULL);
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupSources),
						     -1, "Episode", renderer,
						     "text", 3,
						     NULL);
	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer), "editable", FALSE, NULL);
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupSources),
						     -1, "Length", renderer,
						     "text", 4,
						     NULL);
	renderer = gtk_cell_renderer_text_new();
	g_object_set( G_OBJECT (renderer), "editable", FALSE, NULL);
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupSources),
						     -1, "Recording Date & Time", renderer,
						     "text", 5,
						     NULL);
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_insert_column_with_attributes( GTK_TREE_VIEW (tvDesignSetupSources),
						     -1, "File", renderer,
						     "text", 6,
						     NULL);
	guint c;
	for ( c = 0; c < 7; c++ ) {
		GtkTreeViewColumn *col = gtk_tree_view_get_column( GTK_TREE_VIEW (tvDesignSetupSources), c);
		g_object_set( col,
			      "clickable", TRUE,
			      "reorderable", TRUE,
			      "sort-indicator", TRUE,
			      "resizable", TRUE,
			      "sizing", GTK_TREE_VIEW_COLUMN_AUTOSIZE,
			      NULL);
		gtk_tree_view_column_set_sort_column_id( col, c);
	}
	gtk_tree_sortable_set_sort_column_id( GTK_TREE_SORTABLE (sort_model), 0, GTK_SORT_ASCENDING);



     // ------------- wEDFChooser
	if ( !(wEDFChooser = glade_xml_get_widget( xml, "wEDFChooser")) )
		return -1;

	if ( !(bEDFChooserOptionMove  = glade_xml_get_widget( xml, "bEDFChooserOptionMove"))  ||
	     !(bEDFChooserOptionCopy  = glade_xml_get_widget( xml, "bEDFChooserOptionCopy"))  ||
	     !(bEDFChooserOptionLink  = glade_xml_get_widget( xml, "bEDFChooserOptionLink"))  ||
	     !(bEDFChooserOptionLeave = glade_xml_get_widget( xml, "bEDFChooserOptionLeave")) )
		return -1;

	GtkFileFilter *edf_file_filter = gtk_file_filter_new();
	gtk_file_filter_set_name( edf_file_filter, "EDF files");
	gtk_file_filter_add_pattern( edf_file_filter, "*.edf");
	gtk_file_filter_add_pattern( edf_file_filter, "*.EDF");
	gtk_file_chooser_add_filter( GTK_FILE_CHOOSER (wEDFChooser), edf_file_filter);


     // ------------- wOddSubjectGroupChooser
	if ( !(wOddSubjectGroupChooser = glade_xml_get_widget( xml, "wOddSubjectGroupChooser")) ||
	     !(lOddSubjectGroupSubject = glade_xml_get_widget( xml, "lOddSubjectGroupSubject")) ||
	     !(eOddSubjectGroups       = glade_xml_get_widget( xml, "eOddSubjectGroups")) ||
	     !(bOddSubjectGroupSelect  = glade_xml_get_widget( xml, "bOddSubjectGroupSelect")) )
		return -1;

	gtk_combo_box_set_model( GTK_COMBO_BOX (eOddSubjectGroups),
				 GTK_TREE_MODEL (agh_mDesignSetupGroups));

	renderer = gtk_cell_renderer_text_new();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (eOddSubjectGroups), renderer, FALSE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (eOddSubjectGroups), renderer,
					"text", 0,
					NULL);

	if ( !(lOddSubjectGroupSubject = glade_xml_get_widget( xml, "lOddSubjectGroupSubject")) )
		return -1;


     // ------------- wEDFFileDetails
	if ( !(wEDFFileDetails			= glade_xml_get_widget( xml, "wEDFFileDetails")) ||
	     !(lEDFFileDetailsReport            = glade_xml_get_widget( xml, "lEDFFileDetailsReport")) ||
	     !(lEDFFileDetailsParseProblems     = glade_xml_get_widget( xml, "lEDFFileDetailsParseProblems")) ||
	     !(cEDFFileDetailsParseProblemsShow = glade_xml_get_widget( xml, "cEDFFileDetailsParseProblemsShow")) )
		return -1;

	g_object_set( lEDFFileDetailsReport,
		      "tabs", pango_tab_array_new_with_positions( 2, TRUE,
								  PANGO_TAB_LEFT, 130,
								  PANGO_TAB_LEFT, 190),
		      NULL);

	return 0;
}






// ------- celledited


void
eDesignSetupSubjectCell_edited( GtkCellRendererText *cell,
				const gchar         *path_string,
				const gchar         *new_val,
				gpointer             data)
{
	GtkTreeModel *model = (GtkTreeModel*)data;
	GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
	GtkTreeIter iter;

	gint column = GPOINTER_TO_INT (g_object_get_data (G_OBJECT (cell), "column"));

	gtk_tree_model_get_iter( model, &iter, path);

	gint g, s = -1;
	g = gtk_tree_path_get_indices( path)[0];
	if ( gtk_tree_path_get_depth( path) > 1 )
		s = gtk_tree_path_get_indices( path)[1];

	gint renamed_ok = 0;
	switch ( column ) {
		case 0:  // Name
			if ( s == -1 ) { // renaming group
				renamed_ok = agh_rename_group( g, (gchar*)new_val);
			} else
				renamed_ok = agh_rename_subject( g, s, (gchar*)new_val);
			if ( renamed_ok ) {
				gtk_tree_store_set( GTK_TREE_STORE (model), &iter, column, new_val, -1);

				agh_populate_mDesignSetupGroups();
				agh_populate_mDesignMeasurements();
			} else {
				gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);
				gtk_statusbar_push( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup,
						    "Please choose a unique name.");
			}
		    break;

		case 2:
			agh_set_subject_age( g, s, atoi( new_val));
			gtk_tree_store_set( GTK_TREE_STORE (model), &iter, column, atoi( new_val), -1);
		    break;
		case 1:
			agh_switch_subject_gender( g, s);
			gtk_tree_store_set( GTK_TREE_STORE (model), &iter, column, (new_val[0] == 'M') ?"F" :"M", -1);
		    break;
		case 3:
			agh_set_subject_comment( g, s, new_val);
			gtk_tree_store_set( GTK_TREE_STORE (model), &iter, column, new_val, -1);
		    break;
	}

	gtk_tree_path_free (path);
}







void
eDesignSetupSessionCell_edited( GtkCellRendererText *cell,
				  const gchar         *path_string,
				  const gchar         *new_val,
				  gpointer             data)
{
	GtkTreeModel *model = (GtkTreeModel *)data;
	GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);

	gint g = gtk_tree_path_get_indices( path)[0];
	gtk_tree_path_free (path);

	if ( agh_rename_session_at( new_val, g) )
		gtk_list_store_set( GTK_LIST_STORE (model), &iter, 0, new_val, -1);
}









void
eDesignSetupEpisodeCell_edited( GtkCellRendererText *cell,
				const gchar         *path_string,
				const gchar         *new_val,
				gpointer             data)
{
	GtkTreeModel *model = (GtkTreeModel*)data;
	GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);

	gint g = gtk_tree_path_get_indices( path)[0];
	gtk_tree_path_free (path);

	if ( agh_rename_episodename_at( g, new_val) ) {
		gtk_list_store_set( GTK_LIST_STORE (model), &iter, 0, new_val, -1);
		agh_populate_mDesignMeasurements();
	}
}






void
eDesignSetupChannelCell_edited( GtkCellRendererText *cell,
				const gchar         *path_string,
				const gchar         *new_val,
				gpointer             data)
{
	GtkTreeModel *model = (GtkTreeModel *)data;
	GtkTreePath *path = gtk_tree_path_new_from_string (path_string);
	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);

	gint g = gtk_tree_path_get_indices( path)[0];
	gtk_tree_path_free (path);

	if ( agh_rename_channelname_at( g, new_val) ) {
		gtk_list_store_set( GTK_LIST_STORE (model), &iter, 0, new_val, -1);
		agh_populate_mDesignMeasurements();
	}
}









// ---------- callbacks ------------





void
bDesignSetupAddSubject_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	if ( !paths ) {
		gtk_statusbar_push( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup,
				    "Select a group first to which the new subject will be added.");
		return;
	}
	GtkTreePath *path = (GtkTreePath*) g_list_nth_data( paths, 0);
	gint g = gtk_tree_path_get_indices( path)[0];

	gchar joe[] = "(new-subject)";
	if ( !agh_add_subject_to_group( g, joe) )
		gtk_statusbar_push( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup,
				    "Please first rename \342\200\234(new-subject)\342\200\235.");
	else {
		GtkTreeIter iter, iter_;
		GtkTreePath *path2 = gtk_tree_path_new_from_indices( g, -1);
		gtk_tree_model_get_iter( model, &iter, path2);
		gtk_tree_store_append( agh_mDesignSetupGroupsSubjects, &iter_, &iter);
		gtk_tree_store_set( agh_mDesignSetupGroupsSubjects, &iter_,
				    0, joe,
				    1, "M",
				    2, 22,
				    3, "",
				    4, TRUE,
				    -1);
		gtk_tree_view_expand_row( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects),
					  path2,
					  FALSE);
		gtk_tree_path_free( path2);

		path2 = gtk_tree_model_get_path( model, &iter_);
		gtk_tree_view_set_cursor( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects),
					  path2,
					  gtk_tree_view_get_column( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects), 0),
					  TRUE);
		gtk_tree_path_free( path2);

		agh_populate_mDesignMeasurements();
	}
	gtk_tree_path_free( path);
	g_list_free( paths);
}




void
bDesignSetupAddGroup_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	gchar thejones[] = "(new-group)";
	if ( agh_add_group( thejones) ) {
		GtkTreeIter iter;
		gtk_tree_store_append( agh_mDesignSetupGroupsSubjects, &iter, NULL);
		gtk_tree_store_set( agh_mDesignSetupGroupsSubjects, &iter,
				    0, thejones,
				    3, FALSE,
				    -1);

		GtkTreePath *path = gtk_tree_model_get_path( GTK_TREE_MODEL (agh_mDesignSetupGroupsSubjects),
							     &iter);
		gtk_tree_view_set_cursor( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects),
					  path,
					  gtk_tree_view_get_column( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects),
								    0),
					  TRUE);
		gtk_tree_path_free( path);

		agh_populate_mDesignSetupGroups();
		agh_populate_mDesignMeasurements();
	} else
		gtk_statusbar_push( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup,
				    "Please first rename \342\200\234(new group)\342\200\235.");
}






void
bDesignSetupDeleteOne_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupGroupsSubjects));
	GtkTreeModel *foo;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &foo);
	if ( !paths )
		return;
	GtkTreePath *path = (GtkTreePath*) g_list_nth_data( paths, 0);
	gint g, s = -1;
	g = gtk_tree_path_get_indices( path)[0];
	if ( gtk_tree_path_get_depth( path) > 1 )
		s = gtk_tree_path_get_indices( path)[1];

	if ( s == -1 )
		agh_delete_group_with_subjects( g);
	else
		agh_delete_subject( g, s);
	agh_populate_mDesignSetupGroups();
	agh_populate_mDesignMeasurements();

	GtkTreeIter iter;
	gtk_tree_model_get_iter( GTK_TREE_MODEL (agh_mDesignSetupGroupsSubjects), &iter, path);
	gtk_tree_store_remove( agh_mDesignSetupGroupsSubjects, &iter);

	gtk_tree_path_free( path);
	g_list_free( paths);
}









void
bDesignSetupAddSession_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	gchar newitem[] = "(new session)";
	if ( agh_add_session( newitem) ) {
		GtkTreeIter iter;
		gtk_list_store_append( agh_mDesignSetupSessions, &iter);
		gtk_list_store_set( agh_mDesignSetupSessions, &iter,
				    0, newitem,
				    -1);

		GtkTreePath *path = gtk_tree_model_get_path( GTK_TREE_MODEL (agh_mDesignSetupSessions), &iter);
		gtk_tree_view_set_cursor( GTK_TREE_VIEW (tvDesignSetupSessions),
					  path,
					  gtk_tree_view_get_column( GTK_TREE_VIEW (tvDesignSetupSessions), 0),
					  TRUE);
		gtk_tree_path_free( path);
	}
}



void
bDesignSetupDeleteSession_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupSessions));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	if ( !paths )
		return;
	GtkTreePath *path;
	path = paths ?(GtkTreePath*) g_list_nth_data( paths, 0) :gtk_tree_path_new_from_indices( 0, -1);

	gint at = gtk_tree_path_get_indices( path)[0];

	agh_delete_session_at( at);

	if ( agh_current_session == at )
		agh_current_session = 0;
	else if ( agh_current_session > at )
		agh_current_session--;

	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);
	__agh__disconnect_sessions_combo();
	gtk_list_store_remove( GTK_LIST_STORE (model), &iter);
	__agh__reconnect_sessions_combo();

	agh_populate_mDesignMeasurements();

	gtk_tree_path_free( path);
	g_list_free( paths);
}












void
bDesignSetupAddEpisode_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupEpisodes));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	GtkTreePath *path = NULL;
	gint at;
	if ( paths ) {
		path = (GtkTreePath*) g_list_nth_data( paths, 0);
		at = gtk_tree_path_get_indices( path)[0];
	} else
		at = G_MAXINT;

	gchar newitem[] = "??";
	if ( agh_insert_episodename_at( newitem, at) ) { // -1 == append
		agh_dump_all();
		GtkTreeIter iter;
		gtk_list_store_insert( agh_mDesignSetupEpisodes, &iter, at);
		gtk_list_store_set( agh_mDesignSetupEpisodes, &iter,
				    0, newitem,
				    -1);

		agh_populate_mDesignMeasurements();

		GtkTreePath *path2 = gtk_tree_model_get_path( GTK_TREE_MODEL (agh_mDesignSetupEpisodes), &iter);
		gtk_tree_view_set_cursor( GTK_TREE_VIEW (tvDesignSetupEpisodes),
					  path2,
					  gtk_tree_view_get_column( GTK_TREE_VIEW (tvDesignSetupEpisodes), 0),
					  TRUE);
		gtk_tree_path_free( path2);
	}

	if ( path )
		gtk_tree_path_free( path);
	if ( paths )
		g_list_free( paths);
}



void
bDesignSetupDeleteEpisode_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupEpisodes));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	if ( !paths )
		return;

	GtkTreePath *path;
	path = (GtkTreePath*) g_list_nth_data( paths, 0);

	gint at = gtk_tree_path_get_indices( path)[0];

	agh_delete_episodename_at( at);

	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);

	gtk_list_store_remove( agh_mDesignSetupEpisodes, &iter);

	agh_populate_mDesignMeasurements();

	gtk_tree_path_free( path);
	g_list_free( paths);
}






void
bDesignSetupMoveEpisodeUp_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupEpisodes));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	if ( !paths )
		return;

	GtkTreePath *path;
	path = (GtkTreePath*) g_list_nth_data( paths, 0);

	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);

	gint i = gtk_tree_path_get_indices( path)[0];

	if ( agh_move_episodename_up( i) ) {
		GtkTreeIter iter_dest;
		gtk_tree_path_prev( path);
		gtk_tree_model_get_iter( model, &iter_dest, path);
		gtk_list_store_move_before( agh_mDesignSetupEpisodes, &iter, &iter_dest);

		gtk_tree_view_set_cursor( GTK_TREE_VIEW (tvDesignSetupEpisodes),
					  path,
					  NULL,
					  FALSE);

		agh_populate_mDesignMeasurements();
	}

	gtk_tree_path_free( path);
	g_list_free( paths);
}


void
bDesignSetupMoveEpisodeDown_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupEpisodes));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	if ( !paths )
		return;

	GtkTreePath *path;
	path = (GtkTreePath*) g_list_nth_data( paths, 0);

	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);

	gint i = gtk_tree_path_get_indices( path)[0];

	if ( agh_move_episodename_down( i) ) {
		GtkTreeIter iter_dest;
		gtk_tree_path_next( path);
		gtk_tree_model_get_iter( model, &iter_dest, path);
		gtk_list_store_move_after( agh_mDesignSetupEpisodes, &iter, &iter_dest);

		gtk_tree_view_set_cursor( GTK_TREE_VIEW (tvDesignSetupEpisodes),
					  path,
					  NULL,
					  FALSE);

		agh_populate_mDesignMeasurements();
	}
	gtk_tree_path_free( path);
	g_list_free( paths);
}









void
bDesignSetupAddChannel_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupChannels));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	GtkTreePath *path = NULL;
	gint at;
	if ( paths ) {
		path = (GtkTreePath*) g_list_nth_data( paths, 0);
		at = gtk_tree_path_get_indices( path)[0];
	} else
		at = G_MAXINT;

	gchar newitem[] = "??";
	if ( agh_insert_channelname_at( newitem, at) ) { // -1 == append
		GtkTreeIter iter;
		gtk_list_store_insert( agh_mDesignSetupChannels, &iter, at);
		gtk_list_store_set( agh_mDesignSetupChannels, &iter,
				    0, newitem,
				    -1);

		GtkTreePath *path2 = gtk_tree_model_get_path( model, &iter);
		gtk_tree_view_set_cursor( GTK_TREE_VIEW (tvDesignSetupChannels),
					  path2,
					  gtk_tree_view_get_column( GTK_TREE_VIEW (tvDesignSetupChannels), 0),
					  TRUE);
		gtk_tree_path_free( path2);

		__agh_propagate_current_channel_change();
	}
	gtk_tree_path_free( path);
	g_list_free( paths);
}



void
bDesignSetupDeleteChannel_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupChannels));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	if ( !paths )
		return;

	GtkTreePath *path;
	path = (GtkTreePath*) g_list_nth_data( paths, 0);

	gint at = gtk_tree_path_get_indices( path)[0];

	agh_delete_channelname_at( at);
	__agh_propagate_current_channel_change();

	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);
	__agh__disconnect_channels_combo();
	gtk_list_store_remove( agh_mDesignSetupChannels, &iter);
	__agh__reconnect_channels_combo();

	gtk_tree_path_free( path);
	g_list_free( paths);
}








void
bDesignSetupMoveChannelUp_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupChannels));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	if ( !paths )
		return;

	GtkTreePath *path;
	path = (GtkTreePath*) paths->data;

	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);

	gint i = gtk_tree_path_get_indices( path)[0];

	if ( agh_move_channelname_up( i) ) {
		GtkTreeIter iter_dest;
		gtk_tree_path_prev( path);
		gtk_tree_model_get_iter( model, &iter_dest, path);
		gtk_list_store_move_before( agh_mDesignSetupChannels, &iter, &iter_dest);
		gtk_tree_view_set_cursor( GTK_TREE_VIEW (tvDesignSetupChannels),
					  path,
					  gtk_tree_view_get_column( GTK_TREE_VIEW (tvDesignSetupChannels), 0),
					  FALSE);
		__agh_propagate_current_channel_change();
	}

	gtk_tree_path_free( path);
	g_list_free( paths);
}



void
bDesignSetupMoveChannelDown_clicked_cb( GtkWidget *w, gpointer userdata)
{
	gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignSetup);

	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupChannels));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	if ( !paths )
		return;

	GtkTreePath *path;
	path = (GtkTreePath*) g_list_nth_data( paths, 0);

	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);

	gint i = gtk_tree_path_get_indices( path)[0];

	if ( agh_move_channelname_down( i) ) {
		GtkTreeIter iter_dest;
		gtk_tree_path_next( path);
		gtk_tree_model_get_iter( model, &iter_dest, path);
		gtk_list_store_move_after( agh_mDesignSetupChannels, &iter, &iter_dest);
		gtk_tree_view_set_cursor( GTK_TREE_VIEW (tvDesignSetupChannels),
					  path,
					  NULL,
					  FALSE);
		__agh_propagate_current_channel_change();
	}

	gtk_tree_path_free( path);
	g_list_free( paths);
}







void
bDesignSetupAddChannels1020_clicked_cb()
{
	GtkTreeIter iter;
	guint i;
	for ( i = 0; i < AGH_KNOWN_CHANNELS_TOTAL; i++ )
		if ( agh_insert_channelname_at( __agh_System1020_channels[i], G_MAXINT) ) { // -1 == append
			gtk_list_store_insert( agh_mDesignSetupChannels, &iter, G_MAXINT);
			gtk_list_store_set( agh_mDesignSetupChannels, &iter,
					    0, __agh_System1020_channels[i],
					    -1);
		}
}















void
bDesignSetupSourcesAdd_clicked_cb()
{
	gint edf_chooser_reponse = gtk_dialog_run( GTK_DIALOG (wEDFChooser));

	if ( edf_chooser_reponse != GTK_RESPONSE_ACCEPT )
		return;

	GSList *filenames = gtk_file_chooser_get_filenames( GTK_FILE_CHOOSER (wEDFChooser));
	if ( !filenames )
		return;

	gint option = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (bEDFChooserOptionMove))
		? AGH_SRCATTACH_MOVE
		: gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (bEDFChooserOptionCopy) )
		  ? AGH_SRCATTACH_COPY
		  : gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (bEDFChooserOptionLink) )
		    ? AGH_SRCATTACH_LINK
		    : AGH_SRCATTACH_LEAVE;

	__agh__disconnect_channels_combo();
	__agh__disconnect_sessions_combo();

	static GString *label_text = NULL;
	static GString *edf_validate = NULL;
	static GString *edf_stats = NULL;
	static GtkTextBuffer *textbuf1 = NULL;
	static GtkTextBuffer *textbuf2 = NULL;
	if ( !label_text ) {
		label_text = g_string_sized_new( 256);
		edf_validate = g_string_sized_new( 512);
		edf_stats = g_string_sized_new( 512);
		textbuf1 = gtk_text_view_get_buffer( GTK_TEXT_VIEW (lEDFFileDetailsParseProblems));
		textbuf2 = gtk_text_view_get_buffer( GTK_TEXT_VIEW (lEDFFileDetailsReport));
	}

	GSList *node = filenames;
	while ( node ) {

		gint	edf_validate_ok = agh_edf_is_good( (gchar*) node->data, edf_validate);
		agh_edf_get_stats( (gchar*) node->data, edf_stats);
	retry:	;
		gint add_edf_retval = agh_edf_add_or_replace( (gchar*) node->data,
							      (TSourceAttachMode) option);

		if ( add_edf_retval == -1 ) {
			const gchar *odd_subject = agh_edf_get_subject( (gchar*) node->data);

			g_string_printf( label_text,
					 "The PatientID field, <b>%s</b>, in <i>%s</i> does not "
					 "match any of of the subjects currently registered.\n"
					 "\n"
					 "Please select an existing group to check this new subject into:",
					 odd_subject, node->data);
			gtk_label_set_markup( GTK_LABEL (lOddSubjectGroupSubject),
					      label_text->str);

			if ( gtk_combo_box_get_active( GTK_COMBO_BOX (eOddSubjectGroups)) == -1 )
				gtk_widget_set_sensitive( GTK_WIDGET (bOddSubjectGroupSelect), FALSE);

			if ( gtk_dialog_run( GTK_DIALOG (wOddSubjectGroupChooser)) == GTK_RESPONSE_ACCEPT ) {
				agh_add_subject_to_group( gtk_combo_box_get_active( GTK_COMBO_BOX (eOddSubjectGroups)),
							  odd_subject);
				agh_populate_mDesignSetupGroupsSubjects();
				goto retry;
			} else
				agh_edf_delete( (gchar*) node->data);

		} else if ( add_edf_retval == -2 ) {
			agh_pop_ok_message( "Could not determine Session and/or Episode from the "
					    "RecordingID field, expecting these to appear in this order, "
					    "comma-separated.");

		} else if ( add_edf_retval == 0 ) {
			gtk_statusbar_pop( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignMeasurements);
			gtk_statusbar_push( GTK_STATUSBAR (sbMainStatusBar), agh_sb_context_id_DesignMeasurements,
					    "Added one edf source.");
		      // validate
			gtk_expander_set_expanded( GTK_EXPANDER (cEDFFileDetailsParseProblemsShow),
						   !edf_validate_ok);
			gtk_text_buffer_set_text( textbuf1, edf_validate->str, -1);

		      // gather stats
			gtk_text_buffer_set_text( textbuf2, edf_stats->str, -1);

			gtk_dialog_run( GTK_DIALOG (wEDFFileDetails));
		}

		g_free( node->data);
		node = node->next;
	}

	agh_populate_mDesignSetupEpisodes();
	agh_populate_mDesignSetupChannels();
	agh_populate_mDesignSetupSessions();
	agh_populate_mDesignSetupSources();

	__agh__reconnect_channels_combo();
	__agh__reconnect_sessions_combo();


	g_slist_free( filenames);

	agh_populate_mDesignMeasurements(); // new CMeasurement objects added by
					    // agh_edf_add_or_replace, so no need
					    // to do a full tree scan
}




void
bDesignSetupSourcesDelete_clicked_cb()
{
	GtkTreeSelection *selection = gtk_tree_view_get_selection( GTK_TREE_VIEW (tvDesignSetupSources));
	GtkTreeModel *model;
	GList *paths = gtk_tree_selection_get_selected_rows( selection, &model);
	if ( !paths )
		return;

	GtkTreePath *path;
	path = (GtkTreePath*) g_list_nth_data( paths, 0);

	GtkTreeIter iter;
	gtk_tree_model_get_iter( model, &iter, path);
	gchar *f_name;
	gtk_tree_model_get( model, &iter,
			    6, &f_name,
			    -1);

	agh_edf_delete( f_name);

	gtk_tree_path_free( path);
	g_list_free( paths);

	agh_populate_mDesignSetupSources();
	agh_populate_mDesignMeasurements();
}


// EOF
