// ;-*-C-*- *  Time-stamp: "2008-07-01 00:46:46 hmmr"

/***************************************************************************
 *            agh_ui-modelrun-facility.c
 *
 *  Copyright  2008  Andrei Zavada
 *  Email johnhommer@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <string.h>
#include <math.h>

#include <glade/glade.h>
#include "agh_iface.hh"
#include "agh_ui.h"



GtkWidget
	*wModelRun;

static GtkWidget
	*daModelRunProfile,
	*lModelRunLog,

	*eModelRunVx[AGH_VNUM],

	*cModelRunControls,

	*lModelRunStrideNo;

static GtkTextBuffer
	*__log_text_buffer;


static GdkGC *__gc_SWA, *__gc_SWAsim, *__gc_S, *__gc_scores, *__gc_grid;


static gdouble __display_factor = .1;

static guint __score_hypn_depth[8] = {
	0, 5, 7, 20, 23, 2, 1, 1
};

static gint __zoomed_episode = -1;
static gchar __label_text[62];






gint
agh_construct_ModelRun( GladeXML *xml)
{
	if ( !(wModelRun		= glade_xml_get_widget( xml, "wModelRun")) ||
	     !(daModelRunProfile	= glade_xml_get_widget( xml, "daModelRunProfile")) ||
	     !(lModelRunLog		= glade_xml_get_widget( xml, "lModelRunLog")) ||
	     !(cModelRunControls	= glade_xml_get_widget( xml, "cModelRunControls")) ||
	     !(lModelRunStrideNo	= glade_xml_get_widget( xml, "lModelRunStrideNo")) ||

	     !(eModelRunVx[AGH_Vrs]	= glade_xml_get_widget( xml, "eModelRunVrs")) ||
	     !(eModelRunVx[AGH_Vrc]	= glade_xml_get_widget( xml, "eModelRunVrc")) ||
	     !(eModelRunVx[AGH_Vfc_R]	= glade_xml_get_widget( xml, "eModelRunVfcR")) ||
	     !(eModelRunVx[AGH_Vfc_W]	= glade_xml_get_widget( xml, "eModelRunVfcW")) ||
	     !(eModelRunVx[AGH_VS_0]	= glade_xml_get_widget( xml, "eModelRunVS0")) ||
	     !(eModelRunVx[AGH_VS_U]	= glade_xml_get_widget( xml, "eModelRunVSU")) ||
	     !(eModelRunVx[AGH_Vt_a]	= glade_xml_get_widget( xml, "eModelRunVta")) ||
	     !(eModelRunVx[AGH_Vt_p]	= glade_xml_get_widget( xml, "eModelRunVtp")) ||
	     !(eModelRunVx[AGH_Vgc]	= glade_xml_get_widget( xml, "eModelRunVgc")) )
		return -1;

	g_object_set( lModelRunLog,
		      "tabs", pango_tab_array_new_with_positions( 6, TRUE,
								  PANGO_TAB_LEFT, 50,
								  PANGO_TAB_LEFT, 150,
								  PANGO_TAB_LEFT, 240,
								  PANGO_TAB_LEFT, 330,
								  PANGO_TAB_LEFT, 420,
								  PANGO_TAB_LEFT, 510),
		      NULL);

	__log_text_buffer = gtk_text_view_get_buffer( GTK_TEXT_VIEW (lModelRunLog));


	GdkVisual *visual = gdk_visual_get_system();
	GdkGCValues xx;
	GdkColor c;
	gdk_color_parse( "#005B68", &c), gdk_colormap_alloc_color( gtk_widget_get_colormap( daModelRunProfile), &c, FALSE, TRUE);
	xx.foreground = c, xx.line_width = 1, xx.line_style = GDK_LINE_SOLID;
	__gc_SWA = gtk_gc_get( visual->depth, gtk_widget_get_colormap( daModelRunProfile),
			       &xx, GDK_GC_FOREGROUND | GDK_GC_LINE_WIDTH | GDK_GC_LINE_STYLE);

	gdk_color_parse( "#4F3D02", &c), gdk_colormap_alloc_color( gtk_widget_get_colormap( daModelRunProfile), &c, FALSE, TRUE);
	xx.foreground = c, xx.line_width = 2, xx.line_style = GDK_LINE_ON_OFF_DASH;
	__gc_S = gtk_gc_get( visual->depth, gtk_widget_get_colormap( daModelRunProfile),
			     &xx, GDK_GC_FOREGROUND | GDK_GC_LINE_WIDTH | GDK_GC_LINE_STYLE);

	gdk_color_parse( "#15174C", &c), gdk_colormap_alloc_color( gtk_widget_get_colormap( daModelRunProfile), &c, FALSE, TRUE);
	xx.foreground = c, xx.line_width = 2, xx.line_style = GDK_LINE_SOLID, xx.join_style = GDK_JOIN_ROUND;
	__gc_SWAsim = gtk_gc_get( visual->depth, gtk_widget_get_colormap( daModelRunProfile),
				  &xx, GDK_GC_FOREGROUND | GDK_GC_LINE_WIDTH | GDK_GC_LINE_STYLE | GDK_GC_JOIN_STYLE);

	gdk_color_parse( "#380E54", &c), gdk_colormap_alloc_color( gtk_widget_get_colormap( daModelRunProfile), &c, FALSE, TRUE);
	xx.foreground = c, xx.function = GDK_COPY, xx.line_width = 2, xx.line_style = GDK_LINE_SOLID, xx.cap_style = GDK_CAP_BUTT;
	__gc_scores = gtk_gc_get( visual->depth, gtk_widget_get_colormap( daModelRunProfile),
				  &xx, GDK_GC_FUNCTION | GDK_GC_FOREGROUND | GDK_GC_LINE_WIDTH | GDK_GC_LINE_STYLE | GDK_GC_CAP_STYLE);

	gdk_color_parse( "#8888AA", &c), gdk_colormap_alloc_color( gtk_widget_get_colormap( daModelRunProfile), &c, FALSE, TRUE);
	xx.foreground = c, xx.line_width = 1, xx.line_style = GDK_LINE_SOLID;
	__gc_grid = gtk_gc_get( visual->depth, gtk_widget_get_colormap( daModelRunProfile),
				&xx, GDK_GC_FOREGROUND | GDK_GC_LINE_WIDTH);

	gdk_color_parse( "#FFFFDE", &c), gdk_colormap_alloc_color( gtk_widget_get_colormap( daModelRunProfile), &c, FALSE, TRUE);
	gtk_widget_modify_bg( daModelRunProfile, GTK_STATE_NORMAL, &c);

	return 0;
}








static GArray	*__S_course, *__SWA_course, *__SWA_sim_course, *__scores;
static gdouble	 __SWA_avg_value;

static void	*__R_ptr;

static SConsumerTunableSet __t_set;
static guint	 __stride;

static GString	*__stridelog;



static void
__update_infobar()
{
	guint t;
	for ( t = 0; t < AGH_VNUM; t++ )
		gtk_spin_button_set_value( GTK_SPIN_BUTTON (eModelRunVx[t]),   __t_set. value[t] * agh_v_dispf[t]);

	if ( __stride == 0 )
		snprintf( __label_text, 60, "<small>(initial state)</small>");
	else
		snprintf( __label_text, 60, "Stride # <b>%d</b>", __stride);
	gtk_label_set_markup( GTK_LABEL (lModelRunStrideNo), __label_text);
}


gboolean
__agh_prepare_model_run()
{
	if ( !__S_course ) {
		__S_course       = g_array_new( FALSE, TRUE, sizeof(double));
		__SWA_course     = g_array_new( FALSE, TRUE, sizeof(double));
		__SWA_sim_course = g_array_new( FALSE, TRUE, sizeof(double));
		__scores         = g_array_new( FALSE, FALSE, sizeof(char));
		__stridelog	 = g_string_new( "");
	}

	gint retval = agh_sim_modelrun_setup( agh_j_name->str, agh_get_current_channel_name(),
					      __scores, __SWA_course,
					      &__SWA_avg_value, &__R_ptr);
	switch ( retval ) {
	case AGH_SIMPREP_ENOSCORE:
	case AGH_SIMPREP_ENOMSMT:
		agh_pop_ok_message( "Some measurements are not available, or have not been scored.");
		return FALSE;
	case AGH_SIMPREP_EFARAPART:
		agh_pop_ok_message( "Some measurements in this subject are more than 4 days apart.");
		return FALSE;
	case AGH_SIMPREP_ESIGTYPE:
		agh_pop_ok_message( "There is no signal data in the selected channel, "
				    "or it is not of a suitable type (must be of type \342\200\234EEG\342\200\235).");
		return FALSE;
	case AGH_SIMPREP_EAMENDMENTS_INEFFECTIVE:
		agh_pop_ok_message( "DB2 and AZ amendments are ineffective for single-episode profiles."
				    "Please switch these options off first.");
		return FALSE;
	case AGH_SIMPREP_ERS_NONSENSICAL:
		agh_pop_ok_message( "Tuning the rise rate only makes sense for profiles with multiple episodes."
				    "(Set rs step to 0 to prevent it from being tuned).");
		return FALSE;
	case 0:
		break;
	default:
		agh_pop_ok_message( "Failed to set up this modelrun.");
	}

	agh_sim_modelrun_get_snapshot( __R_ptr, -1,  // request current stride
				       __SWA_sim_course, __S_course, &__t_set, &__stride);
	if ( __stride == 0 )
		agh_sim_modelrun_do_cycle( __R_ptr);

	__update_infobar();

	g_string_printf( __stridelog,
			 "Subject %s (group %s), Channel %s, Freq. range %g-%g Hz\n",
			 agh_j_name->str, agh_get_subject_group( agh_j_name->str), agh_get_current_channel_name(),
			 agh_sim_get_operating_range_from(), agh_sim_get_operating_range_upto());
	gtk_text_buffer_set_text( __log_text_buffer, __stridelog->str, -1);

	__zoomed_episode = -1;

	return TRUE;
}






#define HYPN_DEPTH 30
#define LGD_MARGIN 20

#define X_SPC 4


gboolean
daModelRunProfile_expose_event_cb( GtkWidget *wid, GdkEventExpose *event, gpointer userdata)
{
	gint ht, wd;
	gdk_drawable_get_size( wid->window, &wd, &ht);

	static GArray *lines = NULL;
	static PangoLayout *layout = NULL;

	if ( !lines ) {
		lines = g_array_new( FALSE, FALSE, sizeof(GdkPoint));
		layout = gtk_widget_create_pango_layout( wid, "");
	}

	guint i, ii, ix;

#define L(x) g_array_index (lines, GdkPoint, x)
#define X(x) g_array_index (__SWA_course, double, x)

      // empirical SWA
	guint	cur_ep, cur_ep_start, cur_ep_end,
		n_eps = agh_sim_modelrun_get_n_episodes( __R_ptr),
		tl_start, tl_end, tl_len;

	for ( cur_ep = 0; cur_ep < n_eps; cur_ep++ ) {
		if ( !(__zoomed_episode == -1 || __zoomed_episode == cur_ep) )
			continue;

		cur_ep_start = agh_sim_modelrun_get_nth_episode_start_p( __R_ptr, cur_ep);
		cur_ep_end   = agh_sim_modelrun_get_nth_episode_end_p  ( __R_ptr, cur_ep);

		if ( __zoomed_episode == -1 )
			tl_start = 0, tl_end = tl_len = __SWA_course->len;
		else
			tl_start = cur_ep_start, tl_end = cur_ep_end, tl_len = tl_end - tl_start;

		g_array_set_size( lines, tl_len);

		for ( i = 0; i < tl_len; i++ ) {
			L(i).x = lroundf( (gfloat)i / tl_len * wd);
			L(i).y = ht - LGD_MARGIN-HYPN_DEPTH - X(tl_start+i) * (gfloat)ht / __SWA_avg_value * __display_factor;
		}
		gdk_draw_lines( wid->window, __gc_SWA, (GdkPoint*)lines->data, lines->len);

		snprintf( __label_text, 59, "<b><small>%s</small></b>", agh_get_nth_episode_name(cur_ep));
		pango_layout_set_markup( layout, __label_text, -1);
		gdk_draw_layout( wid->window, __gc_SWA,
				 (__zoomed_episode == -1) ?(gfloat)cur_ep_start/tl_len * wd :10,
				 10,
				 layout);

#undef X
#define X(x) g_array_index (__scores, gchar, x)
	      // hypnogram
		for ( i = 0; i < tl_len; i++ ) {
			gchar c;
			if ( (c = X(tl_start+i)) ) {
				gint y = ht - HYPN_DEPTH + __score_hypn_depth[ SCOREID(c) ];
				gdk_draw_line( wid->window, __gc_scores,
					       lroundf( (gfloat) i   /tl_len * wd), y,
					       lroundf( (gfloat)(i+1)/tl_len * wd), y);
			}
		}
	}


	g_array_set_size( lines, tl_len);

	//tl_start = 0, tl_end = tl_len = __SWA_course->len;
	//tl_start = cur_ep_start, tl_end = cur_ep_end, tl_len = tl_end - tl_start;
	// rely on tl_* as set in the above loop

#undef X
#define X(x) g_array_index (__SWA_sim_course, double, (guint)(x))
      // simulated SWA
	if ( __SWA_sim_course->len && __stride > 0 ) {
		for ( i = 0; i < tl_len; i++ ) {
			L(i).x = rintf( (gfloat)i/tl_len * wd);
			L(i).y = ht - LGD_MARGIN-HYPN_DEPTH - X(tl_start+i) * ht / __SWA_avg_value * __display_factor;
		}
		gdk_draw_lines( wid->window, __gc_SWAsim, (GdkPoint*)lines->data, lines->len);
	}

#undef X
#define X(x) g_array_index (__S_course, double, (guint)(x))
      // Process S
	if ( __S_course->len && __stride > 0 ) {
		for ( i = 0; i < tl_len; i++ ) {
			L(i).x = rintf( (gfloat)i/tl_len * wd);
			L(i).y = ht -  LGD_MARGIN-HYPN_DEPTH - X(tl_start+i) * ht / __SWA_avg_value * __display_factor;
		}
		gdk_draw_lines( wid->window, __gc_S, (GdkPoint*)lines->data, lines->len);
	}
#undef X
#undef L


	guint	pph = 3600/agh_pagesize_get_current(),
		tick_spc_rough = (gfloat)tl_len/(wd/80) / pph,
		tick_spc;
	guint	sizes[8] = { 0, 1, 2, 3, 4, 6, 12, 24 };
	i = 7;
	do  tick_spc = sizes[i--];  while ( tick_spc_rough < tick_spc && i );
	tick_spc *= pph;

	for ( i = 0; i < tl_len; i += tick_spc ) {
		snprintf( __label_text, 59, "<small>%d</small>", (i+tl_start)/pph);
		pango_layout_set_markup( layout, __label_text, -1);
		gdk_draw_layout( wid->window, __gc_grid,
				 (gfloat)i/tl_len * wd,
				 ht - HYPN_DEPTH-LGD_MARGIN + 8,
				 layout);

		gdk_draw_line( wid->window, __gc_grid,
			       (gfloat)i/tl_len * wd, ht - LGD_MARGIN-HYPN_DEPTH,
			       (gfloat)i/tl_len * wd, ht - LGD_MARGIN-HYPN_DEPTH + 5);
	}

	gdk_draw_line( wid->window, __gc_grid, 0, ht-LGD_MARGIN-HYPN_DEPTH +5, wd, ht-LGD_MARGIN-HYPN_DEPTH +5);

	return TRUE;
}





gboolean
daModelRunProfile_scroll_event_cb( GtkWidget *wid, GdkEventScroll *event, gpointer userdata)
{
	switch ( event->direction ) {
	case GDK_SCROLL_DOWN:
		__display_factor /= 1.5;
	    break;
	case GDK_SCROLL_UP:
		__display_factor *= 1.5;
	    break;
	}

	if ( event->state & GDK_CONTROL_MASK ) {
		;
	} else
		;

	gtk_widget_queue_draw( wid);

	return TRUE;
}




gboolean
daModelRunProfile_button_press_event_cb( GtkWidget *wid, GdkEventButton *event, gpointer userdata)
{
	gint ht, wd;
	gdk_drawable_get_size( wid->window, &wd, &ht);

	switch ( event->button ) {
	case 1:
		if ( event->state & GDK_MOD1_MASK ) {
			GdkPixbuf *snapshot = gdk_pixbuf_get_from_drawable( NULL, daModelRunProfile->window,
									    gdk_colormap_get_system(),
									    0, 0, 0, 0,
									    wd, ht);
			if ( snapshot ) {
				GtkWidget *f_chooser = gtk_file_chooser_dialog_new( "Export Profile Snapshot",
										    NULL,
										    GTK_FILE_CHOOSER_ACTION_SAVE,
										    GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
										    GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
										    NULL);
				GtkFileFilter *png_file_filter = gtk_file_filter_new();
				gtk_file_filter_set_name( png_file_filter, "PNG images");
				gtk_file_filter_add_pattern( png_file_filter, "*.png");
				gtk_file_filter_add_pattern( png_file_filter, "*.PNG");
				gtk_file_chooser_add_filter( GTK_FILE_CHOOSER (f_chooser), png_file_filter);
				if ( gtk_dialog_run( GTK_DIALOG (f_chooser)) == GTK_RESPONSE_ACCEPT ) {
					GString *fname = g_string_new( gtk_file_chooser_get_filename( GTK_FILE_CHOOSER (f_chooser)));
					if ( !g_str_has_suffix( fname->str, ".png") && !g_str_has_suffix( fname->str, ".PNG") )
						g_string_append_printf( fname, ".png");
					gdk_pixbuf_save( snapshot, fname->str, "png", NULL, NULL, NULL);
				}
				gtk_widget_destroy( f_chooser);
			}
		} else {
			if ( __zoomed_episode == -1 ) {
				gint ep;
				for ( ep = agh_sim_modelrun_get_n_episodes( __R_ptr)-1; ep > -1; ep-- )
					if ( event->x/wd * __SWA_course->len > agh_sim_modelrun_get_nth_episode_start_p( __R_ptr, ep) ) {
						__zoomed_episode = ep;
						break;
					}
			} else
				__zoomed_episode = -1;
			gtk_widget_queue_draw( wid);
		}
	    break;
	}

	return TRUE;
}










void
bModelRunRun_clicked_cb()
{
	gtk_widget_set_sensitive( cModelRunControls, FALSE);
	agh_set_cursor_busy( TRUE, wModelRun);

      // set tunables per user modification
	guint t;
	for ( t = 0; t < AGH_VNUM; t++ )
		__t_set.value[t] = gtk_spin_button_get_value( GTK_SPIN_BUTTON (eModelRunVx[t])) / agh_v_dispf[t];

      // send tunables to ModelRun
	agh_sim_modelrun_update_tunables( __R_ptr, &__t_set);

	gint n_unstable;
	do {
		agh_sim_modelrun_do_stride( __R_ptr, __stride++, __stridelog);

		n_unstable = agh_sim_modelrun_get_snapshot( __R_ptr, __stride,
							    __SWA_sim_course, __S_course,
							    &__t_set, NULL);

		GtkTextMark *mark = gtk_text_buffer_get_insert( __log_text_buffer);
		GtkTextIter iter;
		gtk_text_buffer_get_iter_at_mark( __log_text_buffer, &iter, mark);

		GtkTextIter iter_end;
		gtk_text_buffer_get_end_iter( __log_text_buffer, &iter_end);
		gtk_text_buffer_delete( __log_text_buffer, &iter, &iter_end);

		gchar mark_name[6];
		snprintf( mark_name, 5, "s%d", __stride-1);
		mark = gtk_text_buffer_create_mark( __log_text_buffer, mark_name, &iter, TRUE);
		gtk_text_buffer_insert_at_cursor( __log_text_buffer, __stridelog->str, -1);

		gtk_text_view_scroll_to_mark( GTK_TEXT_VIEW (lModelRunLog), mark,
					      .2, TRUE, 0., 0.5);

		gtk_widget_queue_draw( daModelRunProfile);
		__update_infobar();

		while ( gtk_events_pending () )
			gtk_main_iteration();

	} while ( !(__t_set.status & AGH_MODRUN_FITSUFFICIENT && __t_set.status & AGH_MODRUN_ALLREQSTABLE) &&
		  !(__t_set.status & AGH_MODRUN_FAILED) );

	gtk_widget_set_sensitive( cModelRunControls, TRUE);
	agh_set_cursor_busy( FALSE, wModelRun);
}




void
bModelRunStride_clicked_cb()
{
	agh_set_cursor_busy( TRUE, wModelRun);

      // set tunables per user modification
	guint t;
	for ( t = 0; t < AGH_VNUM; t++ )
		__t_set.value[t] = gtk_spin_button_get_value( GTK_SPIN_BUTTON (eModelRunVx[t])) / agh_v_dispf[t];

      // send tunables to ModelRun
	agh_sim_modelrun_update_tunables( __R_ptr, &__t_set);

	agh_sim_modelrun_do_stride( __R_ptr, __stride++, __stridelog);
	gint n_unstable = agh_sim_modelrun_get_snapshot( __R_ptr, __stride, __SWA_sim_course, __S_course,
							 &__t_set, NULL);

	GtkTextMark *mark = gtk_text_buffer_get_insert( __log_text_buffer);
	GtkTextIter iter;
	gtk_text_buffer_get_iter_at_mark( __log_text_buffer, &iter, mark);

	GtkTextIter iter_end;
	gtk_text_buffer_get_end_iter( __log_text_buffer, &iter_end);
	gtk_text_buffer_delete( __log_text_buffer, &iter, &iter_end);

	gchar mark_name[6];
	snprintf( mark_name, 5, "s%d", __stride-1);
	mark = gtk_text_buffer_create_mark( __log_text_buffer, mark_name, &iter, TRUE);
	gtk_text_buffer_insert_at_cursor( __log_text_buffer, __stridelog->str, -1);

	gtk_text_view_scroll_to_mark( GTK_TEXT_VIEW (lModelRunLog), mark,
				      .2, TRUE, 0., 0.5);

	gtk_widget_queue_draw( daModelRunProfile);
	__update_infobar();

	agh_set_cursor_busy( FALSE, wModelRun);
}







void
bModelRunStrideBack_clicked_cb()
{
	if ( __stride > 0 ) {
		__stride--;
		agh_sim_modelrun_get_snapshot( __R_ptr, __stride, __SWA_sim_course, __S_course,
					       &__t_set, NULL);
		gtk_widget_queue_draw( daModelRunProfile);
		__update_infobar();

		gchar mark_name[6];
		snprintf( mark_name, 5, "s%d", __stride);
		GtkTextMark *mark = gtk_text_buffer_get_mark( __log_text_buffer, mark_name);
		if ( mark ) {
			GtkTextIter iter;
			gtk_text_buffer_get_iter_at_mark( __log_text_buffer, &iter, mark);
			gtk_text_buffer_place_cursor( __log_text_buffer, &iter);
//			gtk_text_buffer_insert_at_cursor( __log_text_buffer, ">", -1);
		}

		gtk_text_view_place_cursor_onscreen( GTK_TEXT_VIEW (lModelRunLog));
	}
}

void
bModelRunStrideForward_clicked_cb()
{
	__stride++;
	agh_sim_modelrun_get_snapshot( __R_ptr, __stride, __SWA_sim_course, __S_course,
				       &__t_set, &__stride);  // if there is no further strides, get_snapshot will
							      // revert the increment
	gtk_widget_queue_draw( daModelRunProfile);
	__update_infobar();

	gchar mark_name[6];
	snprintf( mark_name, 5, "s%d", __stride);
	GtkTextMark *mark = gtk_text_buffer_get_mark( __log_text_buffer, mark_name);
	GtkTextIter iter;
	if ( mark )
		gtk_text_buffer_get_iter_at_mark( __log_text_buffer, &iter, mark);
//		gtk_text_buffer_insert_at_cursor( __log_text_buffer, ">", -1);
	else
		gtk_text_buffer_get_end_iter( __log_text_buffer, &iter);
	gtk_text_buffer_place_cursor( __log_text_buffer, &iter);

	gtk_text_view_place_cursor_onscreen( GTK_TEXT_VIEW (lModelRunLog));
}




void
bModelRunReset_clicked_cb()
{
	agh_sim_modelrun_reset( __R_ptr);

	agh_sim_modelrun_get_snapshot( __R_ptr, -1, __SWA_sim_course, __S_course,
				       &__t_set, &__stride);
	__stride = 0;
	gtk_widget_queue_draw( daModelRunProfile);
	__update_infobar();
	gtk_text_buffer_set_text( __log_text_buffer, "", -1);
}






void
bModelRunAccept_clicked_cb()
{
	agh_sim_modelrun_save( __R_ptr);

	agh_populate_mSimulations();

	gtk_widget_hide( wModelRun);
}




#define __Vx_value_changed(x) \
	__t_set.value[x] = gtk_spin_button_get_value( e) / agh_v_dispf[x], \
		agh_sim_modelrun_update_tunables( __R_ptr, &__t_set), \
		agh_sim_modelrun_do_cycle( __R_ptr), \
		agh_sim_modelrun_get_snapshot( __R_ptr, -1, __SWA_sim_course, __S_course, NULL, NULL), \
		gtk_widget_queue_draw( daModelRunProfile)

void eModelRunVrs_value_changed_cb ( GtkSpinButton *e, gpointer u)	{ __Vx_value_changed (AGH_Vrs  ); }
void eModelRunVrc_value_changed_cb ( GtkSpinButton *e, gpointer u)	{ __Vx_value_changed (AGH_Vrc  ); }
void eModelRunVfcR_value_changed_cb( GtkSpinButton *e, gpointer u)	{ __Vx_value_changed (AGH_Vfc_R); }
void eModelRunVfcW_value_changed_cb( GtkSpinButton *e, gpointer u)	{ __Vx_value_changed (AGH_Vfc_W); }
void eModelRunVS0_value_changed_cb ( GtkSpinButton *e, gpointer u)	{ __Vx_value_changed (AGH_VS_0 ); }
void eModelRunVSU_value_changed_cb ( GtkSpinButton *e, gpointer u)	{ __Vx_value_changed (AGH_VS_U ); }
void eModelRunVta_value_changed_cb ( GtkSpinButton *e, gpointer u)	{ __Vx_value_changed (AGH_Vt_a ); }
void eModelRunVtp_value_changed_cb ( GtkSpinButton *e, gpointer u)	{ __Vx_value_changed (AGH_Vt_p ); }
void eModelRunVgc_value_changed_cb ( GtkSpinButton *e, gpointer u)	{ __Vx_value_changed (AGH_Vgc  ); }



// EOF
