// ;-*-C-*- *  Time-stamp: "2008-06-14 15:10:24 hmmr"

/***************************************************************************
 *            agh_ui-settings.c
 *
 *  Copyright  2008  Andrei Zavada
 *  Email johnhommer@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <glade/glade.h>
#include "agh_iface.hh"
#include "agh_ui.h"


GtkListStore *agh_mPageSize;
GtkListStore *agh_mFFTParamsWindowType;
GtkListStore *agh_mFFTParamsWindowSize;


GtkWidget
	*ePageSize;

static GtkWidget
	*eFFTParamsBinSize,
	*eFFTParamsWindowSize,
	*eFFTParamsWindowType,
	*eArtifGlitchMag,
	*eArtifSmoothOver,

	*eMsmtConserveMemory;





// ------------------ construct

gint
agh_construct_Settings( GladeXML *xml)
{
	GtkCellRenderer *renderer;

     // construct eDesignSetupPageSize ---------------

	if ( !(ePageSize = glade_xml_get_widget( xml, "ePageSize")) )
		return -1;

	gtk_combo_box_set_model( GTK_COMBO_BOX (ePageSize),
				 GTK_TREE_MODEL (agh_mPageSize));
	renderer = gtk_cell_renderer_text_new();
	gtk_cell_layout_pack_start( GTK_CELL_LAYOUT (ePageSize), renderer, FALSE);
	gtk_cell_layout_set_attributes( GTK_CELL_LAYOUT (ePageSize), renderer,
					"text", 0,
					NULL);

     // ------------- fFFTParams
	if ( !(eFFTParamsBinSize    = glade_xml_get_widget( xml, "eFFTParamsBinSize")) ||
	     !(eFFTParamsWindowSize = glade_xml_get_widget( xml, "eFFTParamsWindowSize")) ||
	     !(eFFTParamsWindowType = glade_xml_get_widget( xml, "eFFTParamsWindowType")) )
		return -1;

	gtk_combo_box_set_model( GTK_COMBO_BOX (eFFTParamsWindowType),
				 GTK_TREE_MODEL (agh_mFFTParamsWindowType));

	renderer = gtk_cell_renderer_text_new();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (eFFTParamsWindowType), renderer, FALSE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (eFFTParamsWindowType), renderer,
					"text", 0,
					NULL);

	gtk_combo_box_set_model( GTK_COMBO_BOX (eFFTParamsWindowSize),
				 GTK_TREE_MODEL (agh_mFFTParamsWindowSize));

	renderer = gtk_cell_renderer_text_new();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (eFFTParamsWindowSize), renderer, FALSE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (eFFTParamsWindowSize), renderer,
					"text", 0,
					NULL);

     // ------------- fArtifacts & misc
	if ( !(eArtifSmoothOver    = glade_xml_get_widget( xml, "eArtifSmoothOver")) ||
	     !(eArtifGlitchMag	   = glade_xml_get_widget( xml, "eArtifGlitchMag")) ||
	     !(eMsmtConserveMemory = glade_xml_get_widget( xml, "eMsmtConserveMemory")) )
		return -1;

	return 0;
}







void
fPageSize_map_cb()
{
	gtk_combo_box_set_active( GTK_COMBO_BOX (ePageSize), agh_pagesize_item);
}





void
ePageSize_changed_cb()
{
	agh_pagesize_set_current_by_item( gtk_combo_box_get_active( GTK_COMBO_BOX (ePageSize)));
	agh_collect_msmts_from_tree();
	agh_populate_mDesignMeasurements();
	agh_populate_mDesignSetupSources();
}






void
fFFTParams_map_cb()
{
	gtk_combo_box_set_active( GTK_COMBO_BOX (eFFTParamsWindowSize), agh_fft_get_window_size_2power());
	gtk_combo_box_set_active( GTK_COMBO_BOX (eFFTParamsWindowType), agh_fft_get_window_type());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eFFTParamsBinSize), agh_fft_get_binsize());
}



void
eFFTParamsWindowType_changed_cb()
{
	agh_fft_set_window_type( gtk_combo_box_get_active( GTK_COMBO_BOX (eFFTParamsWindowType)));

	agh_collect_msmts_from_tree();
	agh_populate_mDesignMeasurements();
}

void
eFFTParamsWindowSize_changed_cb()
{
	agh_fft_set_window_size_2power( gtk_combo_box_get_active( GTK_COMBO_BOX (eFFTParamsWindowSize)));

	gfloat	smallest_binsize = 1. / (2 << agh_fft_get_window_size_2power()),
		cur_binsize = 2 << agh_fft_get_window_size_2power();
	if ( cur_binsize / smallest_binsize != (gint)(cur_binsize / smallest_binsize) ) {
		agh_fft_set_binsize( smallest_binsize, NULL);
		gtk_spin_button_set_value( GTK_SPIN_BUTTON (eFFTParamsBinSize),
					   agh_fft_get_binsize());
	}
	g_object_set( gtk_spin_button_get_adjustment( GTK_SPIN_BUTTON (eFFTParamsBinSize)),
		      "step-increment", 1. / (2 << agh_fft_get_window_size_2power()),
		      NULL);
	g_object_set( eFFTParamsBinSize,
		      "digits", agh_fft_get_window_size_2power()+1, // niftiest shortcut in the whole project
		      NULL);

	agh_collect_msmts_from_tree();
	agh_populate_mDesignMeasurements();
}


void
eFFTParamsBinSize_value_changed_cb()
{
	double corrected;
	if ( !agh_fft_set_binsize( gtk_spin_button_get_value( GTK_SPIN_BUTTON (eFFTParamsBinSize)),
				   &corrected) )
		gtk_spin_button_set_value( GTK_SPIN_BUTTON (eFFTParamsBinSize), corrected);

	agh_collect_msmts_from_tree();
	agh_populate_mDesignMeasurements();
}






void
fArtifacts_map_cb()
{
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eArtifGlitchMag), agh_get_glitch_mag());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eArtifSmoothOver), agh_get_smoothover());
}

void
eArtifGlitchMag_value_changed_cb()
{
	agh_set_glitch_mag( gtk_spin_button_get_value( GTK_SPIN_BUTTON (eArtifGlitchMag)));
}

void
eArtifSmoothOver_value_changed_cb()
{
	agh_set_smoothover( gtk_spin_button_get_value( GTK_SPIN_BUTTON (eArtifSmoothOver)));
}





void eMsmtConserveMemory_toggled_cb()  {}


//EOF
