// ;-*-C-*- *  Time-stamp: "2008-06-24 02:03:34 hmmr"

/***************************************************************************
 *            agh_ui-simulations-settings.c
 *
 *  Copyright  2008  Andrei Zavada
 *  Email johnhommer@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <glade/glade.h>
#include "agh_iface.hh"
#include "agh_iface-tunables.hh"
#include "agh_ui.h"



static GtkWidget
	*eCtrlParamInitRand,
	*eCtrlParamMinSuffFitImprov,
	*eCtrlParamMaxAllowedParamDrift,
	*eCtrlParamStrideLength,
	*eCtrlParamMaxStrides,
	*eCtrlParamRetriesOnSimCycleFail,
	*eCtrlParamTeleportDistance,
	*eCtrlParamMaxHalvingTimes,
	*eCtrlParamDBAmendment1,
	*eCtrlParamDBAmendment2,
	*eCtrlParamAZAmendment,
	*eCtrlParamScoreMVTAsWake,
	*eCtrlParamScoreUnscoredAsWake,
	*eCtrlParamScoreMVTAsPrevScore,
	*eCtrlParamScoreUnscoredAsPrevScore,

	*eTunable_rs,	*eTunable_rs_min,	*eTunable_rs_max,	*eTunable_rs_step,	*eTunable_rs_req,
	*eTunable_rc,	*eTunable_rc_min,	*eTunable_rc_max,	*eTunable_rc_step,	*eTunable_rc_req,
	*eTunable_fcR,	*eTunable_fcR_min,	*eTunable_fcR_max,	*eTunable_fcR_step,	*eTunable_fcR_req,
	*eTunable_fcW,	*eTunable_fcW_min,	*eTunable_fcW_max,	*eTunable_fcW_step,	*eTunable_fcW_req,
	*eTunable_S0,	*eTunable_S0_min,	*eTunable_S0_max,	*eTunable_S0_step,	*eTunable_S0_req,
	*eTunable_SU,	*eTunable_SU_min,	*eTunable_SU_max,	*eTunable_SU_step,	*eTunable_SU_req,
	*eTunable_ta,	*eTunable_ta_min,	*eTunable_ta_max,	*eTunable_ta_step,	*eTunable_ta_req,
	*eTunable_tp,	*eTunable_tp_min,	*eTunable_tp_max,	*eTunable_tp_step,	*eTunable_tp_req,
	*eTunable_gc,	*eTunable_gc_min,	*eTunable_gc_max,	*eTunable_gc_step,	*eTunable_gc_req;









;


gint
agh_construct_SimulationParams( GladeXML *xml)
{
     // ------------- eCtrlParam*
	if ( !(eCtrlParamInitRand		= glade_xml_get_widget( xml, "eCtrlParamInitRand")) ||
	     !(eCtrlParamMinSuffFitImprov	= glade_xml_get_widget( xml, "eCtrlParamMinSuffFitImprov")) ||
	     !(eCtrlParamMaxAllowedParamDrift	= glade_xml_get_widget( xml, "eCtrlParamMaxAllowedParamDrift")) ||
	     !(eCtrlParamStrideLength		= glade_xml_get_widget( xml, "eCtrlParamStrideLength")) ||
	     !(eCtrlParamMaxStrides		= glade_xml_get_widget( xml, "eCtrlParamMaxStrides")) ||
	     !(eCtrlParamRetriesOnSimCycleFail	= glade_xml_get_widget( xml, "eCtrlParamRetriesOnSimCycleFail")) ||
	     !(eCtrlParamTeleportDistance	= glade_xml_get_widget( xml, "eCtrlParamTeleportDistance")) ||
	     !(eCtrlParamMaxHalvingTimes	= glade_xml_get_widget( xml, "eCtrlParamMaxHalvingTimes")) ||
	     !(eCtrlParamDBAmendment1		= glade_xml_get_widget( xml, "eCtrlParamDBAmendment1")) ||
	     !(eCtrlParamDBAmendment2		= glade_xml_get_widget( xml, "eCtrlParamDBAmendment2")) ||
	     !(eCtrlParamAZAmendment		= glade_xml_get_widget( xml, "eCtrlParamAZAmendment")) ||
	     !(eCtrlParamScoreMVTAsWake			= glade_xml_get_widget( xml, "eCtrlParamScoreMVTAsWake")) ||
	     !(eCtrlParamScoreUnscoredAsWake		= glade_xml_get_widget( xml, "eCtrlParamScoreUnscoredAsWake")) ||
	     !(eCtrlParamScoreMVTAsPrevScore		= glade_xml_get_widget( xml, "eCtrlParamScoreMVTAsPrevScore")) ||
	     !(eCtrlParamScoreUnscoredAsPrevScore	= glade_xml_get_widget( xml, "eCtrlParamScoreUnscoredAsPrevScore")) )
		return -1;

      // ------------- eTunable_*
	if ( !(eTunable_rs		= glade_xml_get_widget( xml, "eTunable_rs")) ||
	     !(eTunable_rs_min		= glade_xml_get_widget( xml, "eTunable_rs_min")) ||
	     !(eTunable_rs_max		= glade_xml_get_widget( xml, "eTunable_rs_max")) ||
	     !(eTunable_rs_step		= glade_xml_get_widget( xml, "eTunable_rs_step")) ||
	     !(eTunable_rs_req		= glade_xml_get_widget( xml, "eTunable_rs_req")) ||

	     !(eTunable_rc		= glade_xml_get_widget( xml, "eTunable_rc")) ||
	     !(eTunable_rc_min		= glade_xml_get_widget( xml, "eTunable_rc_min")) ||
	     !(eTunable_rc_max		= glade_xml_get_widget( xml, "eTunable_rc_max")) ||
	     !(eTunable_rc_step		= glade_xml_get_widget( xml, "eTunable_rc_step")) ||
	     !(eTunable_rc_req		= glade_xml_get_widget( xml, "eTunable_rc_req")) ||

	     !(eTunable_fcR		= glade_xml_get_widget( xml, "eTunable_fcR")) ||
	     !(eTunable_fcR_min		= glade_xml_get_widget( xml, "eTunable_fcR_min")) ||
	     !(eTunable_fcR_max		= glade_xml_get_widget( xml, "eTunable_fcR_max")) ||
	     !(eTunable_fcR_step	= glade_xml_get_widget( xml, "eTunable_fcR_step")) ||
	     !(eTunable_fcR_req		= glade_xml_get_widget( xml, "eTunable_fcR_req")) ||

	     !(eTunable_fcW		= glade_xml_get_widget( xml, "eTunable_fcW")) ||
	     !(eTunable_fcW_min		= glade_xml_get_widget( xml, "eTunable_fcW_min")) ||
	     !(eTunable_fcW_max		= glade_xml_get_widget( xml, "eTunable_fcW_max")) ||
	     !(eTunable_fcW_step	= glade_xml_get_widget( xml, "eTunable_fcW_step")) ||
	     !(eTunable_fcW_req		= glade_xml_get_widget( xml, "eTunable_fcW_req")) ||

	     !(eTunable_S0		= glade_xml_get_widget( xml, "eTunable_S0")) ||
	     !(eTunable_S0_min		= glade_xml_get_widget( xml, "eTunable_S0_min")) ||
	     !(eTunable_S0_max		= glade_xml_get_widget( xml, "eTunable_S0_max")) ||
	     !(eTunable_S0_step		= glade_xml_get_widget( xml, "eTunable_S0_step")) ||
	     !(eTunable_S0_req		= glade_xml_get_widget( xml, "eTunable_S0_req")) ||

	     !(eTunable_SU		= glade_xml_get_widget( xml, "eTunable_SU")) ||
	     !(eTunable_SU_min		= glade_xml_get_widget( xml, "eTunable_SU_min")) ||
	     !(eTunable_SU_max		= glade_xml_get_widget( xml, "eTunable_SU_max")) ||
	     !(eTunable_SU_step		= glade_xml_get_widget( xml, "eTunable_SU_step")) ||
	     !(eTunable_SU_req		= glade_xml_get_widget( xml, "eTunable_SU_req")) ||

	     !(eTunable_ta		= glade_xml_get_widget( xml, "eTunable_ta")) ||
	     !(eTunable_ta_min		= glade_xml_get_widget( xml, "eTunable_ta_min")) ||
	     !(eTunable_ta_max		= glade_xml_get_widget( xml, "eTunable_ta_max")) ||
	     !(eTunable_ta_step		= glade_xml_get_widget( xml, "eTunable_ta_step")) ||
	     !(eTunable_ta_req		= glade_xml_get_widget( xml, "eTunable_ta_req")) ||

	     !(eTunable_tp		= glade_xml_get_widget( xml, "eTunable_tp")) ||
	     !(eTunable_tp_min		= glade_xml_get_widget( xml, "eTunable_tp_min")) ||
	     !(eTunable_tp_max		= glade_xml_get_widget( xml, "eTunable_tp_max")) ||
	     !(eTunable_tp_step		= glade_xml_get_widget( xml, "eTunable_tp_step")) ||
	     !(eTunable_tp_req		= glade_xml_get_widget( xml, "eTunable_tp_req")) ||

	     !(eTunable_gc		= glade_xml_get_widget( xml, "eTunable_gc")) ||
	     !(eTunable_gc_min		= glade_xml_get_widget( xml, "eTunable_gc_min")) ||
	     !(eTunable_gc_max		= glade_xml_get_widget( xml, "eTunable_gc_max")) ||
	     !(eTunable_gc_step		= glade_xml_get_widget( xml, "eTunable_gc_step")) ||
	     !(eTunable_gc_req		= glade_xml_get_widget( xml, "eTunable_gc_req")) )
		return -1;

	return 0;
}



gboolean
fSimParamCtlParm_expose_event_cb()
{
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eCtrlParamInitRand),		agh_sim_ctlparm_get_InitRand());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eCtrlParamMinSuffFitImprov),	agh_sim_ctlparm_get_MinSuffFitImprov());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eCtrlParamMaxAllowedParamDrift),	agh_sim_ctlparm_get_MaxAllowedParamDrift());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eCtrlParamStrideLength),		agh_sim_ctlparm_get_StrideLength());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eCtrlParamMaxStrides),		agh_sim_ctlparm_get_MaxStrides());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eCtrlParamRetriesOnSimCycleFail),	agh_sim_ctlparm_get_RetriesoOnSimCycleFail());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eCtrlParamTeleportDistance),	agh_sim_ctlparm_get_TeleportDistance());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eCtrlParamMaxHalvingTimes),		agh_sim_ctlparm_get_MaxHalvingTimes());

	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eCtrlParamDBAmendment1),	agh_sim_ctlparm_get_DBAmendment1());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eCtrlParamDBAmendment2),	agh_sim_ctlparm_get_DBAmendment2());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eCtrlParamAZAmendment),	agh_sim_ctlparm_get_AZAmendment());

	return FALSE;
}

gboolean
fSimParamScores_expose_event_cb()
{
	gtk_toggle_button_set_active( agh_sim_ctlparm_get_ScoreMVTAsWake()
				      ?GTK_TOGGLE_BUTTON (eCtrlParamScoreMVTAsWake)
				      :GTK_TOGGLE_BUTTON (eCtrlParamScoreMVTAsPrevScore), TRUE);
	gtk_toggle_button_set_active( agh_sim_ctlparm_get_ScoreUnscoredAsWake()
				      ?GTK_TOGGLE_BUTTON (eCtrlParamScoreUnscoredAsWake)
				      :GTK_TOGGLE_BUTTON (eCtrlParamScoreUnscoredAsPrevScore), TRUE);

	return FALSE;
}



gboolean
fSimParamTunables_expose_event_cb()
{
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_rs),		agh_v_dispf[AGH_Vrs] * agh_sim_tunable_get_rs());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_rs_min),		agh_v_dispf[AGH_Vrs] * agh_sim_tunable_get_rs_min());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_rs_max),		agh_v_dispf[AGH_Vrs] * agh_sim_tunable_get_rs_max());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_rs_step),		agh_v_dispf[AGH_Vrs] * agh_sim_tunable_get_rs_step());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eTunable_rs_req),	agh_sim_tunable_get_rs_req());

	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_rc),		agh_v_dispf[AGH_Vrc] * agh_sim_tunable_get_rc());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_rc_min),		agh_v_dispf[AGH_Vrc] * agh_sim_tunable_get_rc_min());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_rc_max),		agh_v_dispf[AGH_Vrc] * agh_sim_tunable_get_rc_max());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_rc_step),		agh_v_dispf[AGH_Vrc] * agh_sim_tunable_get_rc_step());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eTunable_rc_req),	agh_sim_tunable_get_rc_req());

	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_fcR),		agh_v_dispf[AGH_Vfc_R] * agh_sim_tunable_get_fcR());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_fcR_min),		agh_v_dispf[AGH_Vfc_R] * agh_sim_tunable_get_fcR_min());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_fcR_max),		agh_v_dispf[AGH_Vfc_R] * agh_sim_tunable_get_fcR_max());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_fcR_step),		agh_v_dispf[AGH_Vfc_R] * agh_sim_tunable_get_fcR_step());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eTunable_fcR_req),	agh_sim_tunable_get_fcR_req());

	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_fcW),		agh_v_dispf[AGH_Vfc_W] * agh_sim_tunable_get_fcW());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_fcW_min),		agh_v_dispf[AGH_Vfc_W] * agh_sim_tunable_get_fcW_min());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_fcW_max),		agh_v_dispf[AGH_Vfc_W] * agh_sim_tunable_get_fcW_max());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_fcW_step),		agh_v_dispf[AGH_Vfc_W] * agh_sim_tunable_get_fcW_step());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eTunable_fcW_req),	agh_sim_tunable_get_fcW_req());

	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_S0),		agh_v_dispf[AGH_VS_0] * agh_sim_tunable_get_S0());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_S0_min),		agh_v_dispf[AGH_VS_0] * agh_sim_tunable_get_S0_min());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_S0_max),		agh_v_dispf[AGH_VS_0] * agh_sim_tunable_get_S0_max());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_S0_step),		agh_v_dispf[AGH_VS_0] * agh_sim_tunable_get_S0_step());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eTunable_S0_req),	agh_sim_tunable_get_S0_req());

	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_SU),		agh_v_dispf[AGH_VS_U] * agh_sim_tunable_get_SU());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_SU_min),		agh_v_dispf[AGH_VS_U] * agh_sim_tunable_get_SU_min());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_SU_max),		agh_v_dispf[AGH_VS_U] * agh_sim_tunable_get_SU_max());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_SU_step),		agh_v_dispf[AGH_VS_U] * agh_sim_tunable_get_SU_step());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eTunable_SU_req),	agh_sim_tunable_get_SU_req());

	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_ta),		agh_v_dispf[AGH_Vt_a] * agh_sim_tunable_get_ta());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_ta_min),		agh_v_dispf[AGH_Vt_a] * agh_sim_tunable_get_ta_min());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_ta_max),		agh_v_dispf[AGH_Vt_a] * agh_sim_tunable_get_ta_max());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_ta_step),		agh_v_dispf[AGH_Vt_a] * agh_sim_tunable_get_ta_step());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eTunable_tp_req),	agh_sim_tunable_get_ta_req());

	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_tp),		agh_v_dispf[AGH_Vt_p] * agh_sim_tunable_get_tp());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_tp_min),		agh_v_dispf[AGH_Vt_p] * agh_sim_tunable_get_tp_min());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_tp_max),		agh_v_dispf[AGH_Vt_p] * agh_sim_tunable_get_tp_max());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_tp_step),		agh_v_dispf[AGH_Vt_p] * agh_sim_tunable_get_tp_step());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eTunable_tp_req),	agh_sim_tunable_get_tp_req());

	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_gc),		agh_v_dispf[AGH_Vgc] * agh_sim_tunable_get_gc());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_gc_min),		agh_v_dispf[AGH_Vgc] * agh_sim_tunable_get_gc_min());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_gc_max),		agh_v_dispf[AGH_Vgc] * agh_sim_tunable_get_gc_max());
	gtk_spin_button_set_value( GTK_SPIN_BUTTON (eTunable_gc_step),		agh_v_dispf[AGH_Vgc] * agh_sim_tunable_get_gc_step());
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (eTunable_gc_req),	agh_sim_tunable_get_gc_req());

	return FALSE;
}




void eCtrlParamInitRand_value_changed_cb( GtkSpinButton *e, gpointer u)			{ agh_sim_ctlparm_set_InitRand			( gtk_spin_button_get_value( e)); }
void eCtrlParamMinSuffFitImprov_value_changed_cb( GtkSpinButton *e, gpointer u)		{ agh_sim_ctlparm_set_MinSuffFitImprov		( gtk_spin_button_get_value( e)); }
void eCtrlParamMaxAllowedParamDrift_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_ctlparm_set_MaxAllowedParamDrift	( gtk_spin_button_get_value( e)); }
void eCtrlParamStrideLength_value_changed_cb( GtkSpinButton *e, gpointer u)		{ agh_sim_ctlparm_set_StrideLength		( gtk_spin_button_get_value( e)); }
void eCtrlParamMaxStrides_value_changed_cb( GtkSpinButton *e, gpointer u)		{ agh_sim_ctlparm_set_MaxStrides		( gtk_spin_button_get_value( e)); }
void eCtrlParamRetriesOnSimCycleFail_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_ctlparm_set_RetriesoOnSimCycleFail	( gtk_spin_button_get_value( e)); }
void eCtrlParamTeleportDistance_value_changed_cb( GtkSpinButton *e, gpointer u)		{ agh_sim_ctlparm_set_TeleportDistance		( gtk_spin_button_get_value( e)); }
void eCtrlParamMaxHalvingTimes_value_changed_cb( GtkSpinButton *e, gpointer u)		{ agh_sim_ctlparm_set_MaxHalvingTimes		( gtk_spin_button_get_value( e)); }
void eCtrlParamScoreMVTAs_toggled_cb( GtkToggleButton *e, gpointer u)			{ agh_sim_ctlparm_set_ScoreMVTAsWake		( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (eCtrlParamScoreMVTAsWake))); }
void eCtrlParamScoreUnscoredAs_toggled_cb( GtkToggleButton *e, gpointer u)		{ agh_sim_ctlparm_set_ScoreUnscoredAsWake	( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (eCtrlParamScoreUnscoredAsWake))); }

#define __update_hook \
	agh_collect_simulations_from_tree(), agh_populate_mSimulations()

void eCtrlParamDBAmendment1_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_ctlparm_set_DBAmendment1( gtk_toggle_button_get_active( e)); __update_hook; }
void eCtrlParamDBAmendment2_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_ctlparm_set_DBAmendment2( gtk_toggle_button_get_active( e)); __update_hook; }
void eCtrlParamAZAmendment_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_ctlparm_set_AZAmendment ( gtk_toggle_button_get_active( e)); __update_hook; }




void eTunable_S0_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_S0( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_VS_0]); }
void eTunable_S0_min_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_S0_min( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_VS_0]); }
void eTunable_S0_max_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_S0_max( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_VS_0]); }
void eTunable_S0_step_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_S0_step( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_VS_0]); }
void eTunable_S0_req_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_tunable_set_S0_req( gtk_toggle_button_get_active( e)); }

void eTunable_SU_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_SU( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_VS_U]); }
void eTunable_SU_min_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_SU_min( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_VS_U]); }
void eTunable_SU_max_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_SU_max( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_VS_U]); }
void eTunable_SU_step_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_SU_step( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_VS_U]); }
void eTunable_SU_req_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_tunable_set_SU_req( gtk_toggle_button_get_active( e)); }

void eTunable_fcR_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_fcR( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vfc_R]); }
void eTunable_fcR_min_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_fcR_min( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vfc_R]); }
void eTunable_fcR_max_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_fcR_max( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vfc_R]); }
void eTunable_fcR_step_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_fcR_step( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vfc_R]); }
void eTunable_fcR_req_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_tunable_set_fcR_req( gtk_toggle_button_get_active( e)); }

void eTunable_fcW_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_fcW( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vfc_W]); }
void eTunable_fcW_min_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_fcW_min( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vfc_W]); }
void eTunable_fcW_max_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_fcW_max( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vfc_W]); }
void eTunable_fcW_step_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_fcW_step( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vfc_W]); }
void eTunable_fcW_req_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_tunable_set_fcW_req( gtk_toggle_button_get_active( e)); }

void eTunable_gc_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_gc( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vgc]); }
void eTunable_gc_min_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_gc_min( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vgc]); }
void eTunable_gc_max_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_gc_max( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vgc]); }
void eTunable_gc_step_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_gc_step( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vgc]); }
void eTunable_gc_req_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_tunable_set_gc_req( gtk_toggle_button_get_active( e)); }

void eTunable_rc_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_rc( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vrc]); }
void eTunable_rc_min_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_rc_min( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vrc]); }
void eTunable_rc_max_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_rc_max( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vrc]); }
void eTunable_rc_step_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_rc_step( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vrc]); }
void eTunable_rc_req_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_tunable_set_rc_req( gtk_toggle_button_get_active( e)); }

void eTunable_rs_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_rs( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vrs]); }
void eTunable_rs_min_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_rs_min( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vrs]); }
void eTunable_rs_max_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_rs_max( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vrs]); }
void eTunable_rs_step_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_rs_step( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vrs]); }
void eTunable_rs_req_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_tunable_set_rs_req( gtk_toggle_button_get_active( e)); }

void eTunable_ta_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_ta( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vt_a]); }
void eTunable_ta_min_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_ta_min( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vt_a]); }
void eTunable_ta_max_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_ta_max( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vt_a]); }
void eTunable_ta_step_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_ta_step( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vt_a]); }
void eTunable_ta_req_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_tunable_set_ta_req( gtk_toggle_button_get_active( e)); }

void eTunable_tp_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_tp( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vt_p]); }
void eTunable_tp_min_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_tp_min( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vt_p]); }
void eTunable_tp_max_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_tp_max( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vt_p]); }
void eTunable_tp_step_value_changed_cb( GtkSpinButton *e, gpointer u)	{ agh_sim_tunable_set_tp_step( gtk_spin_button_get_value( e) / agh_v_dispf[AGH_Vt_p]); }
void eTunable_tp_req_toggled_cb( GtkToggleButton *e, gpointer u)	{ agh_sim_tunable_set_tp_req( gtk_toggle_button_get_active( e)); }



void
bSimParamRevertTunables_clicked_cb()
{
	agh_sim_tunable_stock_defaults();
	fSimParamTunables_expose_event_cb();
}


// EOF
