// ;-*-C-*-   Time-stamp: "2008-06-24 16:05:31 hmmr"

/***************************************************************************
 *            agh-ui.h
 *
 *  Copyright  2008  Andrei Zavada
 *  Email johnhommer@gmail.com

 *  Structures and functions used in ui (plain C) alone
 *
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _AGH_UI_H
#define _AGH_UI_H


#include <gtk/gtk.h>
#include <glade/glade.h>


#if HAVE_CONFIG_H
#  include <config.h>
#endif


G_BEGIN_DECLS

void agh_pop_ok_message( const gchar*);
gint agh_pop_question( const gchar*);



gint agh_ui_init( char *);
gint agh_ui_shutdown( void);


void agh_histfile_read();
void agh_histfile_write();



extern GtkWidget *wMainWindow;


// declarations of models are kept in agh-iface.h
// all other widgets referenced from code are declared here

extern GtkWidget	*tvDesignSetupGroupsSubjects;
extern GtkWidget	*tvDesignSetupEpisodes;
extern GtkWidget	*tvDesignSetupSessions;
extern GtkWidget	*tvDesignSetupChannels;

extern GtkWidget	*tvDesignMeasurements;
extern GtkWidget	*eDesignMsmtChannel;
extern GtkWidget	*eDesignMsmtSession;
extern GtkWidget	*ePageSize;

extern GtkWidget	*eScoringFacPageSize;

extern GtkWidget	*wEDFChooser;
extern GtkWidget	*bEDFChooserOptionMove;
extern GtkWidget	*bEDFChooserOptionCopy;
extern GtkWidget	*bEDFChooserOptionLink;
extern GtkWidget	*bEDFChooserOptionLeave;
extern GtkWidget	*bOddSubjectGroupSelect;

extern GtkWidget	*tvSimulations;
extern GtkWidget	*eSimulationsChannel;
extern GtkWidget	*eSimulationsSession;


extern GtkWidget	*sbMainStatusBar;
extern guint		agh_sb_context_id_General;
extern guint		agh_sb_context_id_DesignSetup;
extern guint		agh_sb_context_id_DesignMeasurements;
extern guint		agh_sb_context_id_Simulations;


extern GtkWidget	*wScoringFacility;
gboolean __agh_prepare_score_facility();

extern GtkWidget	*wModelRun;
gboolean __agh_prepare_model_run();



gint agh_create_models();

gint agh_construct_DesignSetup( GladeXML*);
gint agh_construct_DesignMeasurements( GladeXML*);
gint agh_construct_Settings( GladeXML*);
gint agh_construct_ScoringFacility( GladeXML*);
gint agh_construct_Simulations( GladeXML*);
gint agh_construct_SimulationParams( GladeXML*);
gint agh_construct_ModelRun( GladeXML*);
gint agh_construct_StatusBar( GladeXML*);

void __agh__disconnect_channels_combo();
void __agh__reconnect_channels_combo();
void __agh__disconnect_sessions_combo();
void __agh__reconnect_sessions_combo();
void __agh__disconnect_pagesize_combo();
void __agh__reconnect_pagesize_combo();
void __agh__repopulate_groupsubject_views();

void __agh_propagate_current_session_change();
void __agh_propagate_current_channel_change();



guint SCOREID( gchar c);

extern gchar *__score_names[];




G_END_DECLS

#endif

// EOF
